package datos;

import java.awt.Font;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.Locale;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import modelo.Preferencias;
import modelo.ficheros.TipoFichero;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class PreferenciasXMLParser {
	
	public  void guardarEnFichero ( File fichero, Preferencias p ) 
	throws ParserConfigurationException, TransformerException {
		Document docXML = null;
		
		if ( fichero != null && p != null ) {

			DocumentBuilder docB = DocumentBuilderFactory.newInstance( )
			.newDocumentBuilder( );
			docXML = docB.newDocument( );


			/**
			 * ahora se va a escribir las p en
			 * el docXML
			 */
			if ( docXML != null ) {

				Element preferencias = docXML.createElement( "preferencias" );
				docXML.appendChild( preferencias );



				/** preferencias es el primer hijo del Root. */

				/** ahora introduciremos todas las preferencias en el XML */


				/** Primero los compiladores. */
				Element e = docXML.createElement( "compilador" );

				e.setTextContent( p.getCompilador() );
				preferencias.appendChild( e );


				e = docXML.createElement( "compiladorC" );

				e.setTextContent( p.getCompilador ( TipoFichero.C ) );
				preferencias.appendChild( e );

				e = docXML.createElement( "compiladorCpp" );

				e.setTextContent( p.getCompilador ( TipoFichero.CPP ) );
				preferencias.appendChild( e );

				e = docXML.createElement( "compiladorPascal" );

				e.setTextContent( p.getCompilador ( TipoFichero.PASCAL ) );
				preferencias.appendChild( e );


				e = docXML.createElement( "compiladorFortran" );

				e.setTextContent( p.getCompilador ( TipoFichero.FORTRAN ) );
				preferencias.appendChild( e );


				/** Segundo el directorio de trabajo compilacion. */
				e = docXML.createElement( "dirTrabajoCompilacion" );
				e.setTextContent( p.getWorkspaceCompilacion( ).getAbsolutePath( ) );
				preferencias.appendChild( e );

				/** Tercero opciones compilación. */
				Node nOpciones = preferencias.appendChild( docXML.createElement( "opcionesCompilacion" ) );

				Iterator <String> i = p.getOpcionesCompilador().iterator( );

				while ( i.hasNext( ) ) {
					String op = i.next( );

					e = docXML.createElement( "opcion" );
					e.setTextContent( op );
					nOpciones.appendChild( e );
				}

				nOpciones = preferencias.appendChild( docXML.createElement( "opcionesCompilacionC" ) );

				i = p.getOpcionesCompilador( TipoFichero.C ).iterator( );

				while ( i.hasNext( ) ) {
					String op = i.next( );

					e = docXML.createElement( "opcion" );
					e.setTextContent( op );
					nOpciones.appendChild( e );
				}	


				nOpciones = preferencias.appendChild( docXML.createElement( "opcionesCompilacionCpp" ) );

				i = p.getOpcionesCompilador( TipoFichero.CPP ).iterator( );

				while ( i.hasNext( ) ) {
					String op = i.next( );

					e = docXML.createElement( "opcion" );
					e.setTextContent( op );
					nOpciones.appendChild( e );
				}	


				nOpciones = preferencias.appendChild( docXML.createElement( "opcionesCompilacionPascal" ) );

				i = p.getOpcionesCompilador( TipoFichero.PASCAL ).iterator( );

				while ( i.hasNext( ) ) {
					String op = i.next( );

					e = docXML.createElement( "opcion" );
					e.setTextContent( op );
					nOpciones.appendChild( e );
				}	

				nOpciones = preferencias.appendChild( docXML.createElement( "opcionesCompilacionFortran" ) );

				i = p.getOpcionesCompilador( TipoFichero.FORTRAN ).iterator( );

				while ( i.hasNext( ) ) {
					String op = i.next( );

					e = docXML.createElement( "opcion" );
					e.setTextContent( op );
					nOpciones.appendChild( e );
				}	



				/** Cuarto el editor. */
				e = docXML.createElement( "editor" );

				e.setTextContent( p.getEditor ( ) );
				preferencias.appendChild( e );

				/** Quinto el editor XML. */
				e = docXML.createElement( "editorXML" );

				e.setTextContent( p.getEditorXML ( ) );
				preferencias.appendChild( e );


				/** Sexto directorio de trabajo ejecucion. */
				e = docXML.createElement( "dirTrabajoEjecucion" );
				e.setTextContent( p.getWorkspaceEjecucion( ).getAbsolutePath( ) );
				preferencias.appendChild( e );

				/** Séptimo, gprof. */
				//No tiene sentido que guigprof modifica esta orden :P


				/** Octavo, directorio de trabajo gprof. */
				e = docXML.createElement( "dirTrabajoGprof" );
				e.setTextContent( p.getWorkspaceGprof( ).getAbsolutePath( ) );
				preferencias.appendChild( e );

				/** Noveno opciones gprof. */
				nOpciones = preferencias.appendChild( docXML.createElement( "opcionesCompilacionGprof" ) );

				i = p.getOpcionesGprof( ).iterator( );

				while ( i.hasNext( ) ) {
					String op = i.next( );

					e = docXML.createElement( "opcion" );
					e.setTextContent( op );
					nOpciones.appendChild( e );
				}	


				/** Décimo el traductor. */
				e = docXML.createElement( "traductor" );

				e.setTextContent( p.getTR ( ) );
				preferencias.appendChild( e );


				/** Undécimo el directorio de trabajo traduccion. */
				e = docXML.createElement( "dirTrabajoTraduccion" );
				e.setTextContent( p.getWorkspaceTR( ).getAbsolutePath( ) );
				preferencias.appendChild( e );


				/** Duodécimo opciones traductor. */
				nOpciones = preferencias.appendChild( docXML.createElement( "opcionesCompilacionTraductor" ) );

				i = p.getOpcionesTR( ).iterator( );

				while ( i.hasNext( ) ) {
					String op = i.next( );

					e = docXML.createElement( "opcion" );
					e.setTextContent( op );
					nOpciones.appendChild( e );
				}	

				/** Treceavo el directorio de trabajo general. */
				e = docXML.createElement( "dirTrabajoGeneral" );
				e.setTextContent( p.getWorkspaceDefecto( ).getAbsolutePath( ) );
				preferencias.appendChild( e );


				/** Catorceavo, Fuente*/
				Node nFuente = preferencias.appendChild( docXML.createElement( "fuente" ) );

				Font f = p.getEstadisticasFont( );
				Locale l = p.getLocale( );

				if ( f != null ) {
					e = docXML.createElement( "familia" );
					e.setTextContent( f.getFamily( l ) );
					nFuente.appendChild( e );

					e = docXML.createElement( "nombre" );
					e.setTextContent( f.getFontName( l ) );
					nFuente.appendChild( e );

					e = docXML.createElement( "tamaño" );
					e.setTextContent( String.valueOf( f.getSize( ) ) );
					nFuente.appendChild( e );

					e = docXML.createElement( "estilo" );
					e.setTextContent( String.valueOf( f.getStyle( ) ) );
					nFuente.appendChild( e );
				}

				/** Quinceavo, Look&Feel */
				e = docXML.createElement( "lookAndfeel" );
				e.setTextContent( p.getLookAndFeelName( ) );
				preferencias.appendChild( e );

				/** Dieciseisavo, Idioma */
				Node nLengua = preferencias.appendChild( docXML.createElement( "lengua" ) );

				if ( l != null ) {
					e = docXML.createElement( "idioma" );
					e.setTextContent( l.getLanguage( ) );
					nLengua.appendChild( e );

					e = docXML.createElement( "pais" );
					e.setTextContent( l.getCountry( ) );
					nLengua.appendChild( e );

				}

				/** FIN */



				/** Escritura en el fichero */
				TransformerFactory transformerFactory = TransformerFactory
				.newInstance();
				Transformer transformer = transformerFactory.newTransformer();
				DOMSource source = new DOMSource( docXML );
				StreamResult result = new StreamResult( fichero );
				transformer.transform(source, result);
			}


		}
	}

	public  Preferencias leerDeFichero (File fichero) 
	throws ParserConfigurationException, SAXException, IOException, XPathExpressionException {
		
		Preferencias p = new Preferencias();
		

		if ( fichero != null ) {
			/** Primero hay que pasar el fichero (File) a 
			 * Document para su posterior
			 * interpretación */
			Document docXML = null;


			DocumentBuilder docB = DocumentBuilderFactory.newInstance( )
			.newDocumentBuilder( );
			docXML = docB.parse( fichero );



			/**
			 * ahora se va a leer para rellenar todo lo demás, una vez que tenemos
			 * el docXML
			 */
			if ( docXML != null ) {
				/** primero comprobar que existen preferencias en el fichero. */
				String expresion = "/preferencias";

				XPath xpath = XPathFactory.newInstance( ).newXPath( );

				/** si existe, seguir leyendo las preferencias
				 */
				Node preferencias = (Node) xpath.evaluate( expresion , docXML , XPathConstants.NODE );
				if ( preferencias != null ) {

					/** a continuación, vamos a iniciar el proceso:
					 */

					Node n; // variable auxiliar

					/** Primero los compiladores. */
					n = (Node) xpath.evaluate( "compilador" , preferencias ,
							XPathConstants.NODE );
					if ( n != null && !n.getTextContent( ).isEmpty( ) )
						p.setCompilador ( n.getTextContent( ) );

					n = (Node) xpath.evaluate( "compiladorC" , preferencias ,
							XPathConstants.NODE );
					if ( n != null && !n.getTextContent( ).isEmpty( ) )
						p.setCompilador ( n.getTextContent( ), TipoFichero.C );

					n = (Node) xpath.evaluate( "compiladorCpp" , preferencias ,
							XPathConstants.NODE );
					if ( n != null && !n.getTextContent( ).isEmpty( ) )
						p.setCompilador ( n.getTextContent( ), TipoFichero.CPP );

					n = (Node) xpath.evaluate( "compiladorPascal" , preferencias ,
							XPathConstants.NODE );
					if ( n != null && !n.getTextContent( ).isEmpty( ) )
						p.setCompilador ( n.getTextContent( ), TipoFichero.PASCAL );

					n = (Node) xpath.evaluate( "compiladorFortran" , preferencias ,
							XPathConstants.NODE );
					if ( n != null && !n.getTextContent( ).isEmpty( ) )
						p.setCompilador( n.getTextContent( ), TipoFichero.FORTRAN );

					/** Segundo el directorio de trabajo compilacion. */
					n = (Node) xpath.evaluate( "dirTrabajoCompilacion" , preferencias ,
							XPathConstants.NODE );
					if ( n != null ) {
						File directorioTrabajo = new File( n.getTextContent( ) );
						if ( directorioTrabajo.isDirectory( ) )
							p.setWorkspaceCompilacion( directorioTrabajo );
						else
							p.setWorkspaceCompilacion( null );
					} else
						p.setWorkspaceCompilacion( null );

					/** Tercero opciones compilación. */
					String expression = "/preferencias/opcionesCompilacion/opcion";
					NodeList nodosOpciones = (NodeList) xpath.evaluate( expression ,
							docXML , XPathConstants.NODESET );

					Vector <String> opciones = new Vector <String> ();

					if (nodosOpciones != null ) {
						for ( int i = 0 ; i < nodosOpciones.getLength( ) ; i++ ) {
							Node nodoOpt = nodosOpciones.item( i );

							if (n != null && !nodoOpt.getTextContent( ).isEmpty( ) ) {
								String s = nodoOpt.getTextContent( );
								opciones.add( s );
							}
						}
						p.setOpcionesCompilador( opciones );
					}


					expression = "/preferencias/opcionesCompilacionC/opcion";
					nodosOpciones = (NodeList) xpath.evaluate( expression ,
							docXML , XPathConstants.NODESET );


					opciones.clear();
					if (nodosOpciones != null ) {
						for ( int i = 0 ; i < nodosOpciones.getLength( ) ; i++ ) {
							Node nodoOpt = nodosOpciones.item( i );

							if (n != null && !nodoOpt.getTextContent( ).isEmpty() ) {
								String s = nodoOpt.getTextContent( );
								opciones.add( s );
							}
						}
						p.setOpcionesCompilador( opciones , TipoFichero.C );
					}

					expression = "/preferencias/opcionesCompilacionCpp/opcion";
					nodosOpciones = (NodeList) xpath.evaluate( expression ,
							docXML , XPathConstants.NODESET );


					opciones.clear();
					if (nodosOpciones != null ) {
						for ( int i = 0 ; i < nodosOpciones.getLength( ) ; i++ ) {
							Node nodoOpt = nodosOpciones.item( i );

							if (n != null && !nodoOpt.getTextContent( ).isEmpty() ) {
								String s = nodoOpt.getTextContent( );
								opciones.add( s );
							}
						}
						p.setOpcionesCompilador( opciones , TipoFichero.CPP );
					}


					expression = "/preferencias/opcionesCompilacionPascal/opcion";
					nodosOpciones = (NodeList) xpath.evaluate( expression ,
							docXML , XPathConstants.NODESET );


					opciones.clear();
					if (nodosOpciones != null ) {
						for ( int i = 0 ; i < nodosOpciones.getLength( ) ; i++ ) {
							Node nodoOpt = nodosOpciones.item( i );

							if (n != null && !nodoOpt.getTextContent( ).isEmpty() ) {
								String s = nodoOpt.getTextContent( );
								opciones.add( s );
							}
						}
						p.setOpcionesCompilador( opciones , TipoFichero.PASCAL );
					}


					expression = "/preferencias/opcionesCompilacionFortran/opcion";
					nodosOpciones = (NodeList) xpath.evaluate( expression ,
							docXML , XPathConstants.NODESET );


					opciones.clear();
					if (nodosOpciones != null ) {
						for ( int i = 0 ; i < nodosOpciones.getLength( ) ; i++ ) {
							Node nodoOpt = nodosOpciones.item( i );

							if (n != null && !nodoOpt.getTextContent( ).isEmpty() ) {
								String s = nodoOpt.getTextContent( );
								opciones.add( s );
							}
						}
						p.setOpcionesCompilador( opciones , TipoFichero.FORTRAN );
					}


					/** Cuarto el editor. */
					n = (Node) xpath.evaluate( "editor" , preferencias ,
							XPathConstants.NODE );
					if ( n != null && !n.getTextContent( ).isEmpty( ) )
						p.setEditor( n.getTextContent( ) );

					/** Quinto el editor XML. */
					n = (Node) xpath.evaluate( "editorXML" , preferencias ,
							XPathConstants.NODE );
					if ( n != null && !n.getTextContent( ).isEmpty( ) )
						p.setEditorXML( n.getTextContent( ) );

					/** Sexto directorio de trabajo ejecucion. */
					n = (Node) xpath.evaluate( "dirTrabajoEjecucion" , preferencias ,
							XPathConstants.NODE );
					if ( n != null ) {
						File directorioTrabajo = new File( n.getTextContent( ) );
						if ( directorioTrabajo.isDirectory( ) )
							p.setWorkspaceEjecucion( directorioTrabajo );
						else
							p.setWorkspaceEjecucion( null );
					} else
						p.setWorkspaceEjecucion( null );

					/** Séptimo, gprof. */
					//No tiene sentido que guigprof modifica esta orden :P


					/** Octavo, directorio de trabajo gprof. */
					n = (Node) xpath.evaluate( "dirTrabajoGprof" , preferencias ,
							XPathConstants.NODE );
					if ( n != null ) {
						File directorioTrabajo = new File( n.getTextContent( ) );
						if ( directorioTrabajo.isDirectory( ) )
							p.setWorkspaceGprof( directorioTrabajo );
						else
							p.setWorkspaceGprof( null );
					} else
						p.setWorkspaceGprof( null );

					/** Noveno opciones gprof. */
					expression = "/preferencias/opcionesGprof/opcion";
					nodosOpciones = (NodeList) xpath.evaluate( expression ,
							docXML , XPathConstants.NODESET );


					opciones.clear();
					if (nodosOpciones != null ) {
						for ( int i = 0 ; i < nodosOpciones.getLength( ) ; i++ ) {
							Node nodoOpt = nodosOpciones.item( i );

							if (n != null && !nodoOpt.getTextContent( ).isEmpty() ) {
								String s = nodoOpt.getTextContent( );
								opciones.add( s );
							}
						}
						p.setOpcionesGprof( opciones );
					}


					/** Décimo el traductor. */
					n = (Node) xpath.evaluate( "traductor" , preferencias ,
							XPathConstants.NODE );
					if ( n != null && !n.getTextContent( ).isEmpty( ) )
						p.setTR( n.getTextContent( ) );

					/** Undécimo el directorio de trabajo traduccion. */
					n = (Node) xpath.evaluate( "dirTrabajoTraduccion" , preferencias ,
							XPathConstants.NODE );
					if ( n != null ) {
						File directorioTrabajo = new File( n.getTextContent( ) );
						if ( directorioTrabajo.isDirectory( ) )
							p.setWorkspaceTR( directorioTrabajo );
						else
							p.setWorkspaceTR( null );
					} else
						p.setWorkspaceTR( null );


					/** Duodécimo opciones traductor. */
					expression = "/preferencias/opcionesTraductor/opcion";
					nodosOpciones = (NodeList) xpath.evaluate( expression ,
							docXML , XPathConstants.NODESET );


					opciones.clear();
					if (nodosOpciones != null ) {
						for ( int i = 0 ; i < nodosOpciones.getLength( ) ; i++ ) {
							Node nodoOpt = nodosOpciones.item( i );

							if (n != null && !nodoOpt.getTextContent( ).isEmpty() ) {
								String s = nodoOpt.getTextContent( );
								opciones.add( s );
							}
						}
						p.setOpcionesTR( opciones );
					}

					/** Treceavo el directorio de trabajo general. */
					n = (Node) xpath.evaluate( "dirTrabajoGeneral" , preferencias ,
							XPathConstants.NODE );
					if ( n != null ) {
						File directorioTrabajo = new File( n.getTextContent( ) );
						if ( directorioTrabajo.isDirectory( ) )
							p.setWorkspaceDefecto( directorioTrabajo );
						else
							p.setWorkspaceDefecto( null );
					} else
						p.setWorkspaceDefecto( null );


					/** Catorceavo, Fuente*/

					Node nFuente = (Node) xpath.evaluate( "fuente" , preferencias , 
							XPathConstants.NODE );

					if ( nFuente != null ) {
						String familia = null;
						n = (Node) xpath.evaluate( "familia" , nFuente , 
								XPathConstants.NODE );
						if ( n != null )
							familia = n.getTextContent( );

						String nombre = null;
						n = (Node) xpath.evaluate( "nombre" , nFuente , 
								XPathConstants.NODE );
						if ( n != null )
							nombre = n.getTextContent( );

						int tam = p.getEstadisticasFont( ).getSize( );
						n = (Node) xpath.evaluate( "tamaño" , nFuente , 
								XPathConstants.NODE );
						if ( n != null )
							tam = new Integer ( n.getTextContent( ) ).intValue( );

						int estilo = p.getEstadisticasFont( ).getSize( );
						n = (Node) xpath.evaluate( "estilo" , nFuente , 
								XPathConstants.NODE );
						if ( n != null )
							estilo = new Integer ( n.getTextContent( ) ).intValue( );

						Font f = null;
						if( nombre != null ) {
							f = new Font ( nombre, estilo, tam );
						} else if ( familia != null ) {
							f = new Font ( familia, estilo, tam );
						} else {
							f = p.getEstadisticasFont( ).deriveFont( estilo, tam );
						}
						if ( f != null )
							p.setEstadisticasFont( f );
					}

					/** Quinceavo, Look&Feel */
					n = (Node) xpath.evaluate( "lookAndfeel" , preferencias ,
							XPathConstants.NODE );
					if ( n != null /*&& !n.getTextContent( ).isEmpty( )*/ ) //se pueden añadir vacías
						p.setLookAndFeelName( n.getTextContent( ) );

					/** Dieciseisavo, Idioma */
					Node nLengua = (Node) xpath.evaluate( "lengua" , preferencias , 
							XPathConstants.NODE );

					if ( nFuente != null ) {
						String idioma = null;
						n = (Node) xpath.evaluate( "idioma" , nLengua , 
								XPathConstants.NODE );
						if ( n != null )
							idioma = n.getTextContent( );

						String pais = null;
						n = (Node) xpath.evaluate( "pais" , nLengua , 
								XPathConstants.NODE );
						if ( n != null )
							pais = n.getTextContent( );

						Locale l = null;
						if( idioma != null ) {
							if ( pais != null )
								l = new Locale ( idioma, pais );
							else
								l = new Locale ( idioma );
						} else 

							if ( l != null )
								p.setLocale( l );
					}

					/** FIN */

				}


			}
		}
		return p;
	}


}
