package interfaz.acciones;

import javax.swing.Action;

public class CrearYGestionarAcciones {
	
	private Action	accionAbrirFuente = null;
	private Action	accionCrearCompilacion = null;
	private Action	accionAbrirEjecucion = null;
	private Action	accionAbrirDatosEjecucion = null;
	private Action	accionAbrirEstadisticasXML = null;	
	private Action	accionCerrar = null;
	private Action	accionCerrarTodo = null;
	private Action	accionSalir = null;

	private Action	accionEditar = null;
	private Action	accionActualizar = null;
	private Action	accionCompilarFuente = null;

	private Action	accionCompilar = null;
	private Action	accionNombreEjecutable = null;
	private Action	accionCambiarDirectorioTrabajoCompilacion = null;
	private Action	accionEditarComandoCompilacion = null;
	private Action	accionAñadirFicheros = null;
	private Action	accionQuitarFicheros = null;
	private Action	accionEjecutarCompilado = null;
		
	private Action	accionEjecutar = null;
	private Action	accionAñadirArgumentos = null;	
	private Action	accionQuitarArgumentos = null;
	private Action	accionAñadirFicheroEntradas = null;
	private Action	accionAñadirEntradas = null;
	private Action	accionQuitarEntradas = null;
	private Action	accionCambiarDirectorioTrabajoEjecucion = null;
	private Action	accionNombreGmonOut = null;
	private Action	accionUsarGprofConEjecucion = null;
//	private Action	accionSumarResultados = null;				//TODO

	private Action	accionGprof = null;
	private Action	accionCambiarDirectorioTrabajoGprof = null;
	private Action	accionEditarProgramaGprof = null;
	private Action	accionEditarDatosEjecucionGprof = null;
	private Action	accionNombreSalida = null; 
	private Action	accionEditarComandoGprof = null;
	private Action	accionPasarAXML = null;
		
	private Action	accionNombreXML = null;
	private Action	accionGenerarXML = null;
	private Action	accionEditarSalidaGprof = null;
	private Action	accionCambiarDirectorioTrabajoTR = null;
	private Action	accionTraducir = null;
	private Action	accionEditarComandoTR = null;
	private Action	accionVerEstadisticas = null;

	private Action	accionEditarXML = null;
	private Action	accionVerPerfilPlano = null;
	private Action	accionVerGrafoLlamadas = null;
	private Action	accionVerFuenteAnotado = null;
	private Action	accionVerSalida = null;

	private Action	accionOpcionesAplicacion = null;

	private AccionVistaActiva accionVistaEdicion = null;
	private AccionVistaActiva accionVistaCompilacion = null;
	private AccionVistaActiva accionVistaEjecucion = null;
	private AccionVistaActiva accionVistaGprof = null; 
	private AccionVistaActiva accionVistaTR = null;
	private AccionVistaActiva accionVistaEstadisticas = null;

	private Action	accionAcercaDe = null;

	private Action	accionAbrirSesion = null;
	private Action	accionGuardarSesion = null;
	
	private InterfazIsVacia iiv = null;
	/******SINGLETON**********************/
    private static CrearYGestionarAcciones INSTANCE = null;
	 	 
	    // creador sincronizado para protegerse de posibles problemas  multi-hilo
	    // otra prueba para evitar instanciación múltiple 
	public synchronized static void createInstance( InterfazAcciones ia ) {
		if (INSTANCE == null) { 
			INSTANCE = new CrearYGestionarAcciones( ia );
		} else {
			throw new RuntimeException( "Singleton is already created." );
		}
	}
	 
	public static CrearYGestionarAcciones getInstance() {
		if (INSTANCE == null) throw new RuntimeException( "Instance is not created yet." );
		return INSTANCE;
	}

	public Object clone() throws CloneNotSupportedException {
        throw new CloneNotSupportedException(); 
	}
	
	private CrearYGestionarAcciones ( InterfazAcciones ia ) {
	
		iiv = ia;
		
		accionAbrirFuente = new AccionAbrirFuente( ia );
		accionCrearCompilacion = new AccionCrearCompilacion( ia );
		accionAbrirEjecucion = new AccionAbrirEjecucion(ia);
		accionAbrirDatosEjecucion = new AccionAbrirDatosEjecucion(ia);
		accionAbrirEstadisticasXML = new AccionAbrirEstadisticasXML( ia );	
		accionCerrar = new AccionCerrar( ia );
		accionCerrarTodo = new AccionCerrarTodo( ia );
		accionSalir = new AccionSalir( ia );

		accionEditar = new AccionEditar( ia );
		accionActualizar = new AccionActualizar( ia );
		accionCompilarFuente = new AccionCompilarFuente( ia );

		accionCompilar = new AccionCompilar( ia );
		accionNombreEjecutable = new AccionNombreEjecutable( ia );
		accionCambiarDirectorioTrabajoCompilacion = new AccionCambiarDirectorioTrabajoCompilacion( ia );
		accionEditarComandoCompilacion = new AccionEditarComandoCompilacion( ia );
		accionAñadirFicheros = new AccionAñadirFicheros( ia );
		accionQuitarFicheros = new AccionQuitarFicheros( ia );
		accionEjecutarCompilado = new AccionEjecutarCompilado( ia );
		
		accionEjecutar = new AccionEjecutar( ia );
		accionAñadirArgumentos = new AccionAñadirArgumentos( ia );	
		accionQuitarArgumentos = new AccionQuitarArgumentos( ia );
		accionAñadirFicheroEntradas = new AccionAñadirFicheroEntradas( ia );
		accionAñadirEntradas = new AccionAñadirEntradas( ia );
		accionQuitarEntradas = new AccionQuitarEntradas( ia );
		accionCambiarDirectorioTrabajoEjecucion = new AccionCambiarDirectorioTrabajoEjecucion( ia );
		accionNombreGmonOut = new AccionNombreGmonOut( ia );
		accionUsarGprofConEjecucion = new AccionUsarGprofConEjecucion( ia );
//		accionSumarResultados = new AccionSumarResultados( ia );				//TODO

		accionGprof = new AccionGprof( ia );
		accionCambiarDirectorioTrabajoGprof = new AccionCambiarDirectorioTrabajoGprof( ia );
		accionEditarProgramaGprof = new AccionEditarProgramaGprof( ia );
		accionEditarDatosEjecucionGprof = new AccionEditarDatosEjecucionGprof( ia );
		accionNombreSalida = new AccionNombreSalida( ia ); 
		accionEditarComandoGprof = new AccionEditarComandoGprof( ia );
		accionPasarAXML = new AccionPasarAXML( ia );
		
		accionNombreXML = new AccionNombreXml( ia );
		accionGenerarXML = new AccionGenerarXML( ia );
		accionEditarSalidaGprof = new AccionEditarSalidaGprof( ia );
		accionCambiarDirectorioTrabajoTR = new AccionCambiarDirectorioTrabajoTR( ia );
		accionTraducir = new AccionTraducir( ia );
		accionEditarComandoTR = new AccionEditarComandoTR( ia );
		accionVerEstadisticas = new AccionVerEstadisticas( ia );

		accionEditarXML = new AccionEditarXML( ia );
		accionVerPerfilPlano = new AccionVerPerfilPlano( ia );
		accionVerGrafoLlamadas = new AccionVerGrafoLlamadas( ia );
		accionVerFuenteAnotado = new AccionVerFuenteAnotado( ia );
		accionVerSalida = new AccionVerSalidaGprof( ia );

		accionOpcionesAplicacion = new AccionOpcionesAplicacion( ia );

		accionVistaEdicion = new AccionVistaEdicion( ia );
		accionVistaCompilacion = new AccionVistaCompilacion( ia );
		accionVistaEjecucion = new AccionVistaEjecucion( ia );
		accionVistaGprof = new AccionVistaGprof( ia ); 
		accionVistaTR = new AccionVistaTR( ia );
		accionVistaEstadisticas = new AccionVistaEstadisticas( ia );

		accionAcercaDe = new AccionAcercaDe( ia );

		accionAbrirSesion = new AccionAbrirSesion( ia );
		accionGuardarSesion = new AccionGuardarSesion( ia );
	}

	/************* Gestión Acciones *****************/
	
	public void activarActionsEdicion( boolean vistaActiva, boolean panelNoVacio, boolean siguientePaso ) {
		
		this.getAccionEditar( ).setEnabled( panelNoVacio );
		this.getAccionActualizar( ).setEnabled( panelNoVacio );
		this.getAccionCerrar( ).setEnabled( panelNoVacio );
	
		this.getAccionCompilarFuente( ).setEnabled( siguientePaso );
		
		this.getAccionCerrarTodo( ).setEnabled( !iiv.isVacia() );
		
		this.getAccionVistaEdicion( ).setActivo( vistaActiva );
	}
	
	public void activarActionsCompilacion( boolean vistaActiva, boolean panelNoVacio, boolean siguientePaso ) {
		
		this.getAccionCompilar().setEnabled( panelNoVacio );
		this.getAccionEditarComandoCompilacion( ).setEnabled( panelNoVacio );
		this.getAccionCambiarDirectorioTrabajoCompilacion( ).setEnabled( panelNoVacio );
		this.getAccionQuitarFicheros( ).setEnabled( panelNoVacio );
		this.getAccionAñadirFicheros( ).setEnabled( panelNoVacio );
		this.getAccionNombreEjecutable( ).setEnabled( panelNoVacio );
		this.getAccionCerrar( ).setEnabled( panelNoVacio );
		
		this.getAccionEjecutarCompilado( ).setEnabled( siguientePaso );

		this.getAccionCerrarTodo( ).setEnabled( !iiv.isVacia() );
		
		this.getAccionVistaCompilacion( ).setActivo( vistaActiva );

	}
	
	public void activarActionsEjecucion( boolean vistaActiva, boolean panelNoVacio, boolean siguientePaso ) {
		
		this.getAccionEjecutar( ).setEnabled( panelNoVacio );
		this.getAccionAñadirArgumentos( ).setEnabled( panelNoVacio );
		this.getAccionQuitarArgumentos( ).setEnabled( panelNoVacio );
		this.getAccionAñadirEntradas( ).setEnabled( panelNoVacio );
		this.getAccionQuitarEntradas( ).setEnabled( panelNoVacio );
		this.getAccionAñadirFicheroEntradas( ).setEnabled( panelNoVacio );
		this.getAccionCambiarDirectorioTrabajoEjecucion( ).setEnabled( panelNoVacio );
		this.getAccionNombreGmonOut( ).setEnabled( panelNoVacio );
		this.getAccionCerrar( ).setEnabled( panelNoVacio );

		this.getAccionUsarGprofConEjecucion( ).setEnabled( siguientePaso );
		
		this.getAccionCerrarTodo( ).setEnabled( !iiv.isVacia() );
		
		this.getAccionVistaEjecucion( ).setActivo( vistaActiva );

	}
	
	public void activarActionsGprof( boolean vistaActiva, boolean panelNoVacio, boolean siguientePaso ) {
		
		this.getAccionGprof( ).setEnabled( panelNoVacio );
		this.getAccionEditarProgramaGprof( ).setEnabled( panelNoVacio );
		this.getAccionEditarDatosEjecucionGprof( ).setEnabled( panelNoVacio );
		this.getAccionNombreSalida( ).setEnabled( panelNoVacio );
		this.getAccionCambiarDirectorioTrabajoGprof( ).setEnabled( panelNoVacio );
		this.getAccionCerrar( ).setEnabled( panelNoVacio );
		this.getAccionEditarComandoGprof( ).setEnabled( panelNoVacio );
		
		this.getAccionPasarAXML( ).setEnabled( siguientePaso );
		
		this.getAccionCerrarTodo( ).setEnabled( !iiv.isVacia() );
		
		this.getAccionVistaGprof( ).setActivo( vistaActiva );

	}
	
	public void activarActionsTR( boolean vistaActiva, boolean panelNoVacio, boolean siguientePaso ) {
		
		this.getAccionNombreXML( ).setEnabled( panelNoVacio );
		this.getAccionEditarSalidaGprof( ).setEnabled( panelNoVacio );
		this.getAccionCambiarDirectorioTrabajoTR( ).setEnabled( panelNoVacio );
		this.getAccionTraducir( ).setEnabled( panelNoVacio );
		this.getAccionCerrar( ).setEnabled( panelNoVacio );
		this.getAccionEditarComandoTR( ).setEnabled( panelNoVacio );

		this.getAccionVerEstadisticas( ).setEnabled( siguientePaso );

		
		this.getAccionCerrarTodo( ).setEnabled( !iiv.isVacia() );
		
		this.getAccionVistaTR( ).setActivo( vistaActiva );

	}
	
	public void activarActionsEstadisticas( boolean vistaActiva, boolean panelNoVacio, 
			boolean bPP, boolean bGL, boolean bFA, boolean bSG ) {
		
		this.getAccionCerrar( ).setEnabled( panelNoVacio );
		this.getAccionEditarXML( ).setEnabled( panelNoVacio );
		
		this.getAccionVerPerfilPlano( ).setEnabled( bPP );
		this.getAccionVerGrafoLlamadas( ).setEnabled( bGL );
		this.getAccionVerFuenteAnotado( ).setEnabled( bFA );
		this.getAccionVerSalida( ).setEnabled( bSG );
		
		this.getAccionCerrarTodo( ).setEnabled( !iiv.isVacia() );
		
		this.getAccionVistaEstadisticas( ).setActivo( vistaActiva );

	}



/*	int vistaActiva = 0;
	
	static int NULO = 0;
	static int EDICION = 1;
	static int COMPILACION = 2;
	...
	
	public void activarAcciones( int vistaActiva, boolean panelActivo, boolean siguiente ) {
		switch (vistaActiva) {
		case 1: break;
		
		}
	}*/
	
	/************* GETTERS ***************************/
	
	/**
	 * Esta función devuelve la Acción que se encarga de DialogoAplicacion.
	 * 
	 * @author Ángel García Fernández
	 * @version
	 * @since
	 * @see AcciónDialogoAplicacion, acciónDialogoAplicacion
	 * @return Accion acciónDialogoAplicacion
	 */
	public Action getAccionOpcionesAplicacion ( ) {
		return accionOpcionesAplicacion;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de cerrar el programa.
	 * 
	 * @return Action Acción que se encarga de cerrar el programa
	 */
	public Action getAccionSalir ( ) {
		return accionSalir;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de mostrar la vista
	 * Edición.
	 * 
	 * @return Action Acción que se encarga de mostrar la vista Edición.
	 */
	public AccionVistaActiva getAccionVistaEdicion ( ) {
		return accionVistaEdicion;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de mostrar la vista
	 * Compilación.
	 * 
	 * @return Action Acción que se encarga de mostrar la vista Compilación.
	 */
	public AccionVistaActiva getAccionVistaCompilacion ( ) {
		return accionVistaCompilacion;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de mostrar la vista
	 * Ejecución.
	 * 
	 * @return Action Acción que se encarga de mostrar la vista Ejecución.
	 */
	public AccionVistaActiva getAccionVistaEjecucion ( ) {
		return accionVistaEjecucion;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de mostrar la vista
	 * Gprof.
	 * 
	 * @return Action Acción que se encarga de mostrar la vista Gprof.
	 */
	public AccionVistaActiva getAccionVistaGprof ( ) {
		return accionVistaGprof;
	}
	
	/**
	 * Esta función devuelve la Acción que se encarga de mostrar la vista
	 * Estadísticas.
	 * 
	 * @return Action Acción que se encarga de mostrar la vista Estadísticas.
	 */
	public AccionVistaActiva getAccionVistaEstadisticas ( ) {
		return accionVistaEstadisticas;
	}
	
	/**
	 * Esta función devuelve la Acción que se encarga de mostrar la vista
	 * Traducción.
	 * 
	 * @return Action Acción que se encarga de mostrar la vista Traducción.
	 */
	public AccionVistaActiva getAccionVistaTR( ) {
		return accionVistaTR;
	}
	
	/**
	 * Esta función devuelve la Acción que se encarga de mostrar un pequeño
	 * dialogo de información del programa
	 * 
	 * @return Action Acción que se encarga de mostrar un cuadro de informacion
	 */
	public Action getAccionAcercaDe ( ) {
		return accionAcercaDe;
	}

	/**
	 * @return the accionAbrirFuente
	 */
	public Action getAccionAbrirFuente ( ) {
		return accionAbrirFuente;
	}

	/**
	 * @return the accionAbrirEjecucion
	 */
	public Action getAccionAbrirEjecucion ( ) {
		return accionAbrirEjecucion;
	}

	/**
	 * @return the accionCompilar
	 */
	public Action getAccionCompilar ( ) {
		return accionCompilar;
	}

	public Action getAccionNombreEjecutable ( ) {
		return accionNombreEjecutable;
	}

	public Action getAccionCambiarDirectorioTrabajoCompilacion ( ) {
		return accionCambiarDirectorioTrabajoCompilacion;
	}

	public Action getAccionEditarComandoCompilacion ( ) {
		return accionEditarComandoCompilacion;
	}

	public Action getAccionEditarComandoGprof ( ) {
		return accionEditarComandoGprof;
	}

	public Action getAccionEditarComandoTR ( ) {
		return accionEditarComandoTR;
	}
	
	/**
	 * @return the accionEditar
	 */
	public Action getAccionEditar ( ) {
		return accionEditar;
	}


	/**
	 * @return the accionEjecutar
	 */
	public Action getAccionEjecutar ( ) {
		return accionEjecutar;
	}


/*	*//**
	 * @return the accionSumarResultados
	 *//*
	public Action getAccionSumarResultados ( ) {
		return accionSumarResultados;
	}*/

	/**
	 * @return the accionCambiarNombreGmonOut
	 */
	public Action getAccionNombreGmonOut ( ) {
		return accionNombreGmonOut;
	}

	/**
	 * @return the accionAbrirEstadisticasXML
	 */
	public Action getAccionAbrirEstadisticasXML ( ) {
		return accionAbrirEstadisticasXML;
	}


	/**
	 * Esta función devuelve la Acción que se encarga de cerrar pestañas.
	 * 
	 * @return Action Acción que se encarga de cerrar pestañas.
	 */
	public Action getAccionCerrar ( ) {
		return accionCerrar;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de cerrar todas las pestañas.
	 * 
	 * @return Action Acción que se encarga de cerrar todas las pestañas.
	 */
	public Action getAccionCerrarTodo ( ) {
		return this.accionCerrarTodo;
	}
	
	/**
	 * Esta función devuelve la Acción que se encarga de añadir ficheros a una
	 * compilacion.
	 * 
	 * @return Action Acción que se añadir ficheros a una compilación.
	 */
	public Action getAccionAñadirFicheros ( ) {
		return accionAñadirFicheros;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de quitar fichero a una
	 * compilación.
	 * 
	 * @return Action Acción que se encarga de quitar ficheros en una
	 *         compilación
	 */
	public Action getAccionQuitarFicheros ( ) {
		return accionQuitarFicheros;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de abrir una pestaña de
	 * compilación
	 */
	public Action getAccionCrearCompilacion ( ) {
		return accionCrearCompilacion;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de abrir una pestaña de
	 * compilación con el fichero fuente activo.
	 */
	public Action getAccionCompilarFuente ( ) {
		return accionCompilarFuente;
	}

	/**
	 * Esta función devuelve la Acción que se encarga de actualizar el fichero
	 * fuente activo.
	 */
	public Action getAccionActualizar ( ) {
		return accionActualizar;
	}


	/**
	 * Esta función devuelve la Acción que se encarga de ejecutar el actual fichero
	 * compilado.
	 */
	public Action getAccionEjecutarCompilado ( ) {
		return accionEjecutarCompilado;
	}


	public Action getAccionAbrirDatosEjecucion ( ) {
		return accionAbrirDatosEjecucion;
	}

	public Action getAccionTraducir ( ) {
		return accionTraducir;
	}


	public Action getAccionCambiarDirectorioTrabajoEjecucion ( ) {
		return this.accionCambiarDirectorioTrabajoEjecucion;
	}

	public Action getAccionAñadirEntradas ( ) {
		return this.accionAñadirEntradas;
	}

	public Action getAccionQuitarEntradas ( ) {
		return this.accionQuitarEntradas;
	}
	
	public Action getAccionAñadirFicheroEntradas () {
		return this.accionAñadirFicheroEntradas;
	}

	public Action getAccionAñadirArgumentos ( ) {
		return this.accionAñadirArgumentos;
	}

	public Action getAccionQuitarArgumentos ( ) {
		return this.accionQuitarArgumentos;
	}

	public Action getAccionCambiarDirectorioTrabajoGprof ( ) {
		return this.accionCambiarDirectorioTrabajoGprof;
	}


	public Action getAccionEditarProgramaGprof ( ) {
		return this.accionEditarProgramaGprof;
	}

	public Action getAccionEditarDatosEjecucionGprof ( ) {
		return this.accionEditarDatosEjecucionGprof;
	}
	
	public Action getAccionGprof ( ) {
		return this.accionGprof;
	}

	public Action getAccionUsarGprofConEjecucion ( ) {
		return accionUsarGprofConEjecucion;
	}
	
	public Action getAccionGuardarSesion ( ) {
		return this.accionGuardarSesion;
	}
	
	public Action getAccionAbrirSesion ( ) {
		return this.accionAbrirSesion;
	}

	public Action getAccionVerEstadisticas( ) {
		return this.accionVerEstadisticas;
	}

	public Action getAccionGenerarXML ( ) {
		return this.accionGenerarXML;
	}

	public Action getAccionNombreXML ( ) {
		return this.accionNombreXML;
	}

	public Action getAccionEditarSalidaGprof ( ) {
		return this.accionEditarSalidaGprof;
	}
	
	public Action getAccionCambiarDirectorioTrabajoTR ( ) {
		return this.accionCambiarDirectorioTrabajoTR;
	}
	
	public Action getAccionNombreSalida ( ) {
		return this.accionNombreSalida;
	}

	public Action getAccionPasarAXML ( ) {
		return this.accionPasarAXML;
	}
	
	public Action getAccionEditarXML ( ) {
		return this.accionEditarXML;
	}
	
	public Action getAccionVerPerfilPlano ( ) {
		return this.accionVerPerfilPlano;
	}

	public Action getAccionVerGrafoLlamadas ( ) {
		return this.accionVerGrafoLlamadas;
	}

	public Action getAccionVerFuenteAnotado ( ) {
		return this.accionVerFuenteAnotado;
	}
	
	public Action getAccionVerSalida ( ) {
		return this.accionVerSalida;
	}
}
