package interfaz.dialogos.acercaDe;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;

import net.miginfocom.swing.MigLayout;

public class DialogoAcercaDe extends JDialog {

	/** serial version uid. */
	private static final long serialVersionUID = 8674829277697895228L;
	
	/**
	 * Hace falta este this_dialog para usar el this dentro del ActionListener.	
	 */
	private JDialog this_dialog = this;
	
	/**
	 * recursos para dar soporte sobre idiomas
	 */
	static ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos");
	
	/**  Botón de cerrar, cierra el diálogo y confirma todas las opciones realizadas hasta ahora. */
	private JButton botCerrar = new JButton( idiomas.getString( "eti_botCerrar" ) );
	private ActionListener aclCerrar = new ActionListener () {
		public void actionPerformed( ActionEvent e) {
			this_dialog.setVisible(false);
			this_dialog.dispose();
		}
	};
	/** Añadir los actionListener al boton. */
	{
		botCerrar.addActionListener( aclCerrar );
	}
	
	/** Acerca De */
	private JTextArea acercaDe = new JTextArea ( idiomas.getString( "atx_dialog-acercaDe" ));
	{
		acercaDe.setBackground( this.getBackground( ) );
		acercaDe.setBorder( BorderFactory.createCompoundBorder( new EtchedBorder() , new EmptyBorder( 5, 10, 5, 10 ) ) );
		acercaDe.setEditable( false );
	}
	
	public void showDialog( ) {
		this.setVisible( true );
		this.getRootPane( ).setDefaultButton( botCerrar );
		this.setLocationRelativeTo( this.getParent( ) );
	}

	/**
	 * Constructor de la clase 
	 * @param owner
	 */
	public DialogoAcercaDe(Frame owner) {
		/** ventana padre, título del diálogo y que sea modal*/
		super(owner, idiomas.getString( "eti_dialog-acercaDe"), true );
		
		this.setDefaultCloseOperation( DISPOSE_ON_CLOSE );
		
		/** colocar elementos del diálogo. */
		this.setLayout( new MigLayout ( "fill, inset unrel" ) );
		this.add( acercaDe, "align center, wrap" ); //alinear centro	
		this.add( this.botCerrar, "align center, gaptop unrel" ); //alinear izquierda
		
		/** default button -> Cerrar */
		this.getRootPane().setDefaultButton( botCerrar );
		
		/** ESC button -> Cerrar */
		KeyStroke esc = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
	    this.getRootPane( ).registerKeyboardAction( aclCerrar, "ACTION_CLOSE", esc, JComponent.WHEN_IN_FOCUSED_WINDOW);
		
	    /** Empaquetar y colocar */
		this.pack( );
		setLocationRelativeTo( owner );
		this.setResizable( false );
	}
	
	/**
	 * Función main para pruebas.
	 */
	public static void main(String[] args) {
		javax.swing.JFrame v = new javax.swing.JFrame();
		javax.swing.JPanel p = new javax.swing.JPanel();
		javax.swing.JButton b = new javax.swing.JButton ( "Mostrar diálogo Acerca De GUIgprof" );
		p.add(b);
		v.setContentPane( p );
		v.pack();
		final DialogoAcercaDe d = new DialogoAcercaDe( v );;
		
		b.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            	d.showDialog();
            }
        });

		v.setDefaultCloseOperation( javax.swing.JFrame.EXIT_ON_CLOSE );
		v.setVisible(true);
	}
}
