/**
 * Filtro que se aplica a los ficheros de tipo
 * .session, que contienen información
 * de una sesión en GUIgprof. 
 */

package interfaz.dialogos.dialogoAbrir;

import java.io.File;
import java.util.ResourceBundle;

import javax.swing.filechooser.FileFilter;

import modelo.ficheros.UtilidadesExtensionFichero;
import negocio.PreferenciasSingleton;


public class SesionFilter extends FileFilter {

	ResourceBundle propiedades = ResourceBundle.getBundle("interfaz.idiomas.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias().getLocale( ) );


	/** Acepta todos los directorios y los ficheros sesión .session */
	public boolean accept(File f) {
		boolean resultado = false;
		if (f.isDirectory())
			resultado = true;
		else if ( UtilidadesExtensionFichero.isSesion(f) )
			resultado = true;
		else
			resultado = false;

		return resultado;
	}

	/** Descripción del filtro */
	public String getDescription() {
		return propiedades.getString("des_Sesion");
	}

}



