package interfaz.dialogos.dialogoCambiarComando;

import interfaz.dialogos.JMessageText;
import interfaz.dialogos.dialogoNuevoArgumento.DialogoNuevoArgumento;

import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Collection;
import java.util.Iterator;
import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import net.miginfocom.swing.MigLayout;

public class DialogoCambiarComando extends JDialog {

	/** serial version UID */
	private static final long		serialVersionUID	= 1L;

	/** recursos para dar soporte sobre idiomas */
	static ResourceBundle			idiomas				= ResourceBundle
																.getBundle( "interfaz.idiomas.Recursos" );
	/** recursos de iconos etc... */
	static ResourceBundle recursos = ResourceBundle.getBundle("interfaz.Recursos");
	
	/** valor devuelto por el showDialog. */
	boolean ok_option = false;
	
	/** valor de si hay cambios */
	boolean cambios = false;
	
	/** opción de sólo opciones, no deja modificar la orden */
	boolean onlyOptions = false;
	
	/** comando inicial */
	Vector < String >				vComandoInicial			= new Vector < String > ();
	
	/** orden */
	Vector < String > 				vComandoFinal			= new Vector < String > ();
	
	/** Esta propiedad sirve para usar this en las clases internas. */
	DialogoCambiarComando			this_dialog			= this;

	static String					TITULO_DIALOGO		= idiomas
																.getString( "eti_cambiarComando-dialog" );

	static String					ORDEN				= idiomas
																.getString( "s_etiOrden" );
	static String					SELORDEN			= idiomas.getString("s_etiSelOrden" );
	static String					ARGUMENTOS			= idiomas
																.getString( "s_etiArgumentos" );
	static String					GUARDAR				= idiomas
																.getString( "eti_botGuardar" );
	static String					CANCELAR			= idiomas
																.getString( "eti_botCancelar" );
	static String					AÑADIR				= idiomas.getString( "eti_añadirArgumentos" );
	static String					QUITAR				= idiomas.getString( "eti_quitarArgumentos" );
	static ImageIcon				IMG_AÑADIR			= (ImageIcon) recursos.getObject( "img_añadir" );
	static ImageIcon				IMG_QUITAR			= (ImageIcon) recursos.getObject( "img_quitar" );
	static String					COMANDO_COMPLETO	= idiomas.getString( "s_etiComandoCompleto" );

	
	/** Botón GUARDAR */
	private JButton					botGuardarFuente	= new JButton( GUARDAR );
	private ActionListener			aclGuardarFuente	= new ActionListener( ) {
							public void actionPerformed (
										ActionEvent e ) {

								if ( cambios ) {
									ok_option = true;
								}
								this_dialog.setVisible(false);
								this_dialog.dispose( );
							}
	};
	{
		/** Añadir los actionListener a los botones. */
		botGuardarFuente.addActionListener( aclGuardarFuente );
	}

	/** Botón CANCELAR */
	private JButton					botCancelar			= new JButton( CANCELAR );
	private ActionListener			aclCancelar			= new ActionListener( ) {
															public void actionPerformed (
																	ActionEvent e ) {
																ok_option = false;
																this_dialog.setVisible( false );
																this_dialog.dispose( );
																		
																}
														};
	{
		/** Añadir los actionListener a los botones. */
		botCancelar.addActionListener( aclCancelar );
	}

	/** Texto de Orden */
	JTextField						txtOrden			= new JTextField( );


	private DocumentListener		dolOrden			= new DocumentListener( ) {

															public void changes (
																	DocumentEvent docEv ) {
																
																if ( !vComandoFinal.firstElement().equals(txtOrden.getText( ) ) ) {
																	vComandoFinal.set( 0 , txtOrden.getText( ) );
																	ComandoChanged();
																	if ( !vComandoInicial.firstElement().equals( vComandoFinal.firstElement() ) )
																		this_dialog.cambios = true;
																}																
															}

															@Override
															public void changedUpdate (
																	DocumentEvent docEv ) {
																changes(docEv);
															}

															@Override
															public void insertUpdate (
																	DocumentEvent docEv ) {
																changes( docEv );

															}

															@Override
															public void removeUpdate (
																	DocumentEvent docEv ) {
																changes( docEv );

															}
														};
	{
		/** Añadir el DocumentListener al text field. */
		txtOrden.getDocument( ).addDocumentListener( dolOrden );
	}

	
	/** Texto de Argumentos */
	JTextField						txtArgumentos		= new JTextField( );
	
	private JList lisArgumentos = new JList();
	private DefaultListModel molisArgumentos = new DefaultListModel();
	{
		lisArgumentos.setLayoutOrientation( JList.VERTICAL );
		lisArgumentos.setModel( molisArgumentos );
	}

	private JButton				botAñadir			= new JButton( IMG_AÑADIR );
	private ActionListener			aclAñadir			= new ActionListener( ) {
		public void actionPerformed (
				ActionEvent e ) {
			DialogoNuevoArgumento dialogoAbrir = new DialogoNuevoArgumento();
			
			String argumento = "";
			/** Mostrar el dialogo de abrir (DialogoNuevoArgumento). */
			if ( dialogoAbrir.showDialog( this_dialog ) == DialogoNuevoArgumento.OK_OPTION ) {
				/** Coger el argumento introducido. */
				argumento = dialogoAbrir.getArgumento( );

				/* añadir argumento */
				if ( !argumento.equals( "" ) ) {
					molisArgumentos.addElement( argumento );
					vComandoFinal.add( argumento );
					cambios = true;
					ComandoChanged();
				}
			}
			
		}
	};
	{
		/** Añadir los actionListener a los botones. */
		botAñadir.addActionListener( aclAñadir );
		botAñadir.setToolTipText( AÑADIR );
		txtArgumentos.addActionListener( aclAñadir );
	}
	
	private JButton				botQuitar			= new JButton( IMG_QUITAR );
	private ActionListener			aclQuitar			= new ActionListener( ) {
		public void actionPerformed (
				ActionEvent e ) {
			Object[] seleccionados = lisArgumentos.getSelectedValues( ); 
			for ( int i = 0 ; i < seleccionados.length ; i++ ) {
						molisArgumentos.removeElement( seleccionados[i] );
						vComandoFinal.remove( seleccionados[i] );
						cambios = true;
						ComandoChanged();
			}

		}
	};
	{
		/** Añadir los actionListener a los botones. */
		botQuitar.addActionListener( aclQuitar );
		botQuitar.setToolTipText( QUITAR );
	}

	/*JTextField txtComandoCompleto = new JTextField();*/
	JMessageText txtComandoCompleto = new JMessageText();
	
	public boolean showDialog ( ) {
		ok_option = false;
		this.setVisible( true );
		this.setLocationRelativeTo( this.getParent( ) );
		this.setResizable( false );
		
		return ok_option;
	}

	/** Constructor de la clase
	 * @param owner
	 */
	public DialogoCambiarComando ( Frame owner ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , true );

		setComando( new Vector <String> () );
		setOnlyOptions( false );
		
		init();
	}
	public DialogoCambiarComando (Dialog owner) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , true );

		setComando( new Vector <String> () );
		setOnlyOptions( false );
		
		init();	
	}
	public DialogoCambiarComando (Window owner) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , Dialog.ModalityType.APPLICATION_MODAL );

		setComando( new Vector <String> () );
		setOnlyOptions( false );
		
		init();	
	}
	
	public DialogoCambiarComando ( Frame owner , Collection <String> co ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , true );

		setComando( co );
		setOnlyOptions( false );
		
		init();
	}
	public DialogoCambiarComando ( Dialog owner , Collection <String> co ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , true );

		setComando( co );
		setOnlyOptions( false );
		
		init();	
	}
	public DialogoCambiarComando ( Window owner , Collection <String> co ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , Dialog.ModalityType.APPLICATION_MODAL );

		setComando( co );
		setOnlyOptions( false );
		
		init();	
	}
	
	public DialogoCambiarComando ( Frame owner , Collection <String> co, boolean onlyOps ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , true );

		setComando( co );
		setOnlyOptions( onlyOps );
		
		init();
	}
	public DialogoCambiarComando ( Dialog owner , Collection <String> co, boolean onlyOps ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , true );

		setComando( co );
		setOnlyOptions( onlyOps );
		
		init();	
	}
	public DialogoCambiarComando ( Window owner , Collection <String> co, boolean onlyOps ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , Dialog.ModalityType.APPLICATION_MODAL );

		setComando( co );
		setOnlyOptions( onlyOps );
		
		init();	
	}
	
	private void init () {
		this.setDefaultCloseOperation( DISPOSE_ON_CLOSE );

		/** colocar elementos del diálogo. */
		this.setLayout( new MigLayout( "fill, inset unrel" ) );

		JPanel orden = new JPanel( new MigLayout( "fill" ) );
		orden.setBorder( BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), ORDEN) );
		JLabel selOrden = new JLabel (SELORDEN);
		//orden.setFocusable( false );
		//this. ...
		orden.add( selOrden , "growx, gaptop unrel, gapafter rel, sgy alturaNormal, sgx txt" );
		orden.add( txtOrden, "growx, sgy alturaNormal, sgx txt, wrap, gapbottom rel" );
		this.add(orden, "wrap, growx");

		JPanel argumentos = new JPanel( new MigLayout( "fill" ) );
		argumentos.setBorder( BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), ARGUMENTOS) );		
		//JLabel argumentos = new JLabel (ARGUMENTOS);
		//orden.setFocusable( false );
		//argumentos.add( new JLabel("Lista de argumentos:") , "growx, sgx txt, sgy alturaNormal,gaptop rel" );
		argumentos.add( new JScrollPane( lisArgumentos ) , "growx, gaptop rel, sgx txt, wrap, spany 3, growy" );
		//argumentos.add( txtArgumentos , "growx, sgy alturaNormal, sgx txt, gaptop unrel, gapbottom rel, aligny top, wrap" );
		argumentos.add( botAñadir, "pushy,aligny top, sg boton, split 2, flowy, alignx center, gaptop rel" );
		argumentos.add( botQuitar, "pushy, aligny top, sg boton, wrap, gaptop rel" );
		this.add(argumentos, "wrap, growx");

		JPanel comando_completo = new JPanel( new MigLayout( "fill" ) );
		comando_completo.setBorder( BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), COMANDO_COMPLETO) );
		//JLabel comando_completo = new JLabel( COMANDO_COMPLETO);
		//comando_completo.setFocusable( false );
		//this.add( comando_completo, "gaptop rel, gapbottom rel, sgx txt, sgy alturaNormal, wrap, aligny top" );
		txtComandoCompleto.setFocusable( false );
		comando_completo.add( txtComandoCompleto, "spanx 2, growx, gapbottom unrel, sgy alturaNormal, wrap, alignx center" );
		this.add(comando_completo, "wrap, growx");
		
		this.add( this.botGuardarFuente ,
				"gaptop unrel, span, split 2, alignx center, sg botones" );
		this.add( this.botCancelar , "sg botones" );

		/** default button -> Guardar */
		this.getRootPane( ).setDefaultButton( botGuardarFuente );

		/** ESC button -> Cancelar */
		KeyStroke esc = KeyStroke.getKeyStroke( KeyEvent.VK_ESCAPE , 0 );
		this.getRootPane( ).registerKeyboardAction( aclCancelar ,
				"ACTION_CLOSE" , esc , JComponent.WHEN_IN_FOCUSED_WINDOW );
		
		this.addWindowListener(new WindowAdapter() {
	        @Override public void windowClosing( WindowEvent e ) {
	            botCancelar.doClick( 1 );
	        }
	    });


		/** Empaquetar y colocar */
		this.pack( );
		this.setLocationRelativeTo( this.getParent( ) );
		this.setResizable( false );
	}
	
	private void inicializar() {
	
		/** comando principal */
		if ( vComandoFinal.size( ) > 0 )
			txtOrden.setText( vComandoFinal.firstElement( ) );
		
		/** lista desplegable de opciones */
		molisArgumentos.removeAllElements( );
		if ( vComandoFinal.size( ) > 1 )	
			for ( int i = 1; i < vComandoFinal.size( ); i++ )
				molisArgumentos.addElement( vComandoFinal.get( i ) );
		
		ComandoChanged();
		
	}
	
	private void ComandoChanged() {
		String comando_completo = new String();
		Iterator < String > it = vComandoFinal.iterator( );
		while ( it.hasNext( ) )
			comando_completo += it.next() + " "; 
		txtComandoCompleto.setText( comando_completo );
	}
	
	public Vector <String> getComando ( ) {
		return vComandoFinal;
	}

	@SuppressWarnings ( "unchecked" )
	public void setComando ( Collection <String> o ) {
		vComandoInicial = new Vector < String > (o);
		vComandoFinal =  ( Vector < String > ) vComandoInicial.clone();
		
		cambios = false; 
		
		inicializar();
	}
	
	public boolean isOnlyOptions() {
		return onlyOptions;
	}
	
	public void setOnlyOptions ( boolean onlyOps ) {
		onlyOptions = onlyOps;
		txtOrden.setEditable( !onlyOptions );
	}

	
	/** Función main para pruebas. */
	public static void main ( String [] args ) {
		javax.swing.JFrame v = new javax.swing.JFrame( TITULO_DIALOGO );
		javax.swing.JPanel p = new javax.swing.JPanel( );
		javax.swing.JButton b = new javax.swing.JButton(
				"Mostrar diálogo Cambiar Comando" );
		p.add( b );
		v.setContentPane( p );
		v.pack( );
		
		Vector <String> a = new Vector <String> () ;
		a.add( "Hola" );a.add(  "que tal"); a.add( "como" ); a.add( "estás" );
		final DialogoCambiarComando d = new DialogoCambiarComando( v , a );

		b.addActionListener( new ActionListener( ) {
			public void actionPerformed ( ActionEvent e ) {
				d.showDialog( );
			}
		} );

		v.setDefaultCloseOperation( javax.swing.JFrame.EXIT_ON_CLOSE );
		v.setVisible( true );
	}

}
