package interfaz.dialogos.dialogoFuente;


import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JDialog;
import javax.swing.KeyStroke;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;


import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GraphicsEnvironment;
import java.awt.Font;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import java.util.ResourceBundle;

import negocio.PreferenciasSingleton;
import net.miginfocom.swing.MigLayout;

public class DialogoFuente extends JDialog {

	/** serial version UID */
	private static final long		serialVersionUID	= 1L;

	/** recursos para dar soporte sobre idiomas */
	static ResourceBundle			idiomas				= ResourceBundle
																.getBundle( "interfaz.idiomas.Recursos", 
																		PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ));

	/** valor devuelto por el showDialog. */
	boolean ok_option = false;
	
	/** Fuente principal */
	Font							fuenteInicial			= PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias().getEstadisticasFont( );
	Font							fuenteFinal				= fuenteInicial;

	/** Esta propiedad sirve para usar this en las clases internas. */
	DialogoFuente					this_dialog			= this;

	/** Cadenas sujetas a cambios por idiomas. */
	static String					TITULO_DIALOGO		= idiomas
																.getString( "eti_fuente-dialog" );

	static String					FUENTE				= idiomas
																.getString( "s_etiFuente" );
	static String					TAMAÑO				= idiomas
																.getString( "s_etiTamaño" );
	static String					ESTILO				= idiomas
																.getString( "s_etiEstilo" );
	static String					VISTAPREVIA			= idiomas
																.getString( "s_vistaPrevia" );
	static String					GUARDAR				= idiomas
																.getString( "eti_botGuardar" );
	static String					CANCELAR			= idiomas
																.getString( "eti_botCancelar" );

	static String					NORMAL				= idiomas
																.getString( "s_normal" );
	static String					ITALICA				= idiomas
																.getString( "s_italica" );
	static String					NEGRITA				= idiomas
																.getString( "s_negrita" );
	static String					ITALICA_NEGRITA		= idiomas
																.getString( "s_italicaYnegrita" );

	/** Botón GUARDAR */
	private JButton					botGuardarFuente	= new JButton( GUARDAR );
	private ActionListener			aclGuardarFuente	= new ActionListener( ) {
															public void actionPerformed (
																	ActionEvent e ) {
																
																if ( fuenteFinal
																		.getSize( ) > 40
																		|| fuenteFinal
																				.getSize( ) < 5 ) {
																	JOptionPane
																			.showMessageDialog(
																					this_dialog ,
																					idiomas
																							.getString( "s_tamaño_grande" ) ,
																					TITULO_DIALOGO ,
																					JOptionPane.ERROR_MESSAGE );
																	fuenteFinal = fuenteInicial;
																} else {
																	fuenteInicial = fuenteFinal;
																	/**
																	 * Cerrar el
																	 * diálogo
																	 */
																	ok_option = true;
																	this_dialog
																			.setVisible( false );
																	this_dialog
																			.dispose( );
																}
															}
														};
	{
		/** Añadir los actionListener a los botones. */
		botGuardarFuente.addActionListener( aclGuardarFuente );
	}

	/** Botón CANCELAR */
	private JButton					botCancelar			= new JButton( CANCELAR );
	private ActionListener			aclCancelar			= new ActionListener( ) {
															public void actionPerformed (
																	ActionEvent e ) {
																fuenteFinal = fuenteInicial;
																this_dialog
																		.setVisible( false );
																this_dialog
																		.dispose( );
															}
														};
	{
		/** Añadir los actionListener a los botones. */
		botCancelar.addActionListener( aclCancelar );
	}

	/** Texto de Fuentes */
	JTextField						txtFuente			= new JTextField(
																fuenteInicial
																		.getName( ) );
	{
		txtFuente.setEditable( false );
	}

	/** Lista de Fuentes */
	JList							lisFuente			= new JList(
																GraphicsEnvironment
																		.getLocalGraphicsEnvironment( )
																		.getAvailableFontFamilyNames( ) );
	private ListSelectionListener	lslFuente			= new ListSelectionListener( ) {

															@Override
															public void valueChanged (
																	ListSelectionEvent arg0 ) {
																if ( lisFuente
																		.getSelectedValue( ) != null ) {
																	fuenteFinal = new Font(
																			String
																					.valueOf( lisFuente
																							.getSelectedValue( ) ) ,
																			fuenteFinal
																					.getStyle( ) ,
																			fuenteFinal
																					.getSize( ) );

																	txtFuente
																			.setText( fuenteFinal
																					.getName( ) );
																	actualizarDialogo( );
																}
															}
														};
	{
		/** Añadir el listSelectionListener a la lista. */
		lisFuente.addListSelectionListener( lslFuente );
	}

	/** Texto de tamaños */
	JTextField						txtTamaño			= new JTextField(
																String
																		.valueOf( fuenteInicial
																				.getSize( ) ) ,
																2 );
	{
		/** Sólo números */
		txtTamaño.addKeyListener( new KeyAdapter( ) {
			public void keyTyped ( KeyEvent e ) {
				char caracter = e.getKeyChar( );

				// Verificar si la tecla pulsada no es un digito
				if ( ( ( caracter < '0' ) || ( caracter > '9' ) )
						&& ( caracter != KeyEvent.VK_BACK_SPACE ) ) {
					e.consume( ); // ignorar el evento de teclado
				}
			}
		} );
		txtTamaño.setEditable( true );
	}
	private DocumentListener		dolTamaño			= new DocumentListener( ) {

															public void changes (
																	DocumentEvent docEv ) {
																if ( !txtTamaño
																		.getText( )
																		.equals(
																				"" ) ) {
																	int t = Integer
																			.parseInt( txtTamaño
																					.getText( ) );
																	fuenteFinal = fuenteFinal
																			.deriveFont( (float) t );
																	actualizarDialogo( );
																}
															}

															@Override
															public void changedUpdate (
																	DocumentEvent docEv ) {
																// changes(docEv);
															}

															@Override
															public void insertUpdate (
																	DocumentEvent docEv ) {
																changes( docEv );

															}

															@Override
															public void removeUpdate (
																	DocumentEvent docEv ) {
																changes( docEv );

															}
														};
	{
		/** Añadir el Listener del JTEXTFIELD. */
		txtTamaño.getDocument( ).addDocumentListener( dolTamaño );
	}

	/** Lista de tamaños */
	JList							lisTamaño			= new JList(
																new String [] {
			"8", "9", "10", "11", "12", "14", "16", "18", "20", "22", "25",
			"28", "32"											} );
	private ListSelectionListener	lslTamaño			= new ListSelectionListener( ) {

															@Override
															public void valueChanged (
																	ListSelectionEvent arg0 ) {
																if ( lisTamaño
																		.getSelectedValue( ) != null ) {
																	txtTamaño
																			.setText( lisTamaño
																					.getSelectedValue( )
																					.toString( ) );
																}
															}
														};
	{
		/** Añadir el listSelectionListener a la lista. */
		lisTamaño.addListSelectionListener( lslTamaño );
	}

	/** Texto de Estilos */
	JTextField						txtEstilo			= new JTextField( );
	{
		txtEstilo.setEditable( false );
	}

	/** Lista de Estilos */
	JList							lisEstilo			= new JList(
																new String [] {
			NORMAL, NEGRITA, ITALICA, ITALICA_NEGRITA			} );
	private ListSelectionListener	lslEstilo			= new ListSelectionListener( ) {

															@Override
															public void valueChanged (
																	ListSelectionEvent arg0 ) {

																if ( lisEstilo
																		.getSelectedValue( ) != null ) {

																	fuenteFinal = fuenteFinal
																			.deriveFont( lisEstilo
																					.getSelectedIndex( ) );

																	txtEstilo
																			.setText( lisEstilo
																					.getSelectedValue( )
																					.toString( ) );
																	actualizarDialogo( );
																}
															}
														};
	{
		/** Añadir el listSelectionListener a la lista. */
		lisEstilo.addListSelectionListener( lslEstilo );
	}

	/** Texto Prueba */
	JTextField						txtPrueba			= new JTextField(
																"abcdefghi ABCDEFGHI" );
	{
		txtPrueba.setFont( fuenteFinal );
		txtPrueba.setBackground( this.getBackground( ) );
		txtPrueba.setHorizontalAlignment( JTextField.CENTER );
	}

	{
		setEstilo( );
	}

	public boolean showDialog ( ) {
		this.ok_option = false;
		this.setVisible( true );
		this.setLocationRelativeTo( this.getParent( ) );
		this.setResizable( false );
		return ok_option;
	}

	/** Constructores de la clase
	 * @param owner
	 */
	public DialogoFuente ( Frame owner ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , true );

		init();
	}
	public DialogoFuente ( Dialog owner ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , true );

		init();
	}
	public DialogoFuente ( Window owner ) {
		/** ventana padre, título del diálogo y que sea modal */
		super( owner , TITULO_DIALOGO , Dialog.ModalityType.APPLICATION_MODAL );

		init();
	}
	private void init () {
		this.setDefaultCloseOperation( DISPOSE_ON_CLOSE );

		/** colocar elementos del diálogo. */
		this.setLayout( new MigLayout( "fill, inset unrel" ) );

		this.add( new JLabel( FUENTE ) , "gapafter unrel, sgx fuente" );
		this.add( new JLabel( TAMAÑO ) , "gapafter unrel, sgx tamano" );
		this.add( new JLabel( ESTILO ) , "sgx estilo, wrap" );
		this.add( txtFuente , "sgx fuente" );
		this.add( txtTamaño , "sgx tamano" );
		this.add( txtEstilo , "sgx estilo, wrap" );
		this.add( new JScrollPane( lisFuente ) , "sgx fuente, sgy listas" );
		this.add( new JScrollPane( lisTamaño ) , "sgx tamano, sgy listas" );
		this
				.add( new JScrollPane( lisEstilo ) ,
						"sgx estilo, sgy listas, wrap" );

		this.add( new JLabel( VISTAPREVIA ) , "gaptop unrel, wrap" );
		this.add( this.txtPrueba , "span, growx, sgy listas, wrap" );

		this.add( this.botGuardarFuente ,
				"gaptop unrel, span, split 2, alignx center, sg botones" );
		this.add( this.botCancelar , "sg botones" );

		/** default button -> Guardar */
		this.getRootPane( ).setDefaultButton( botGuardarFuente );

		/** ESC button -> Cancelar */
		KeyStroke esc = KeyStroke.getKeyStroke( KeyEvent.VK_ESCAPE , 0 );
		this.getRootPane( ).registerKeyboardAction( aclCancelar ,
				"ACTION_CLOSE" , esc , JComponent.WHEN_IN_FOCUSED_WINDOW );

		/** Empaquetar y colocar */
		this.pack( );
		this.setLocationRelativeTo( this.getParent( ) );
		this.setResizable( false );
	}

	public Font getFuente ( ) {
		return fuenteFinal;
	}

	public void setFuente ( Font f ) {
		this.txtTamaño.setText( String.valueOf( f.getSize( ) ) );
		this.txtFuente.setText( f.getName( ) );
		setEstilo( );
		fuenteInicial = f;
		fuenteFinal = fuenteInicial;
	}

	private void actualizarDialogo ( ) {
		this.txtPrueba.setFont( fuenteFinal );
		this.txtPrueba.revalidate( );
	}

	private void setEstilo ( ) {
		int estilo = fuenteFinal.getStyle( );
		switch ( estilo ) {
		case 0 :
			this.txtEstilo.setText( NORMAL );
			this.lisEstilo.setSelectedIndex( 0 );
			break;
		case 1 :
			this.txtEstilo.setText( NEGRITA );
			this.lisEstilo.setSelectedIndex( 1 );
			break;
		case 2 :
			this.txtEstilo.setText( ITALICA );
			this.lisEstilo.setSelectedIndex( 2 );
			break;
		case 3 :
			this.txtEstilo.setText( ITALICA_NEGRITA );
			this.lisEstilo.setSelectedIndex( 3 );
			break;
		}
	}

	/** Función main para pruebas. */
	public static void main ( String [] args ) {
		javax.swing.JFrame v = new javax.swing.JFrame( TITULO_DIALOGO );
		javax.swing.JPanel p = new javax.swing.JPanel( );
		javax.swing.JButton b = new javax.swing.JButton(
				"Mostrar diálogo Fuentes" );
		p.add( b );
		v.setContentPane( p );
		v.pack( );
		final DialogoFuente d = new DialogoFuente( v );
		;

		b.addActionListener( new ActionListener( ) {
			public void actionPerformed ( ActionEvent e ) {
				d.showDialog( );
			}
		} );

		v.setDefaultCloseOperation( javax.swing.JFrame.EXIT_ON_CLOSE );
		v.setVisible( true );
	}

}
