package interfaz.dialogos.dialogoSalir;

import interfaz.GUI;
import interfaz.acciones.CrearYGestionarAcciones;

import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JOptionPane;

public class DialogoCerrarWindowListener implements  WindowListener {

	private Frame ventana;
	
	public DialogoCerrarWindowListener ( Frame f ) {
		ventana = f;
	}
	
	@Override
	public void windowActivated ( WindowEvent e ) {
		
	}

	@Override
	public void windowClosed ( WindowEvent e ) {

	}

	@Override
	public void windowClosing ( WindowEvent e ) {
		int r = 0;

		if ( ventana instanceof GUI ) {
			if ( !( (GUI) ventana).isVacia() ) {

				r = new DialogoSalir( ventana ).showDialog( );

				if (r == DialogoSalir.GUARDAR ) {
					CrearYGestionarAcciones.getInstance().getAccionGuardarSesion( ).actionPerformed( null );
					/** Salir de la aplicación */
					negocio.guigprof.getInstance().cerrarAplicacion( );
				} else if ( r == DialogoSalir.NO_GUARDAR ) {
					/** Salir de la aplicación */
					negocio.guigprof.getInstance().cerrarAplicacion( );
				}
			} else 
				/** Si el GUI está vacío, salir de la aplicación directamente,
				 * sin preguntar nada. */
				negocio.guigprof.getInstance().cerrarAplicacion( );
		} else { /* Esto sirve para cuando se está usando con una clase ventana 
		distinta a GUI. Es decir, en los test. */ 
			r = new DialogoSalir( ventana ).showDialog( );

			if ( r == DialogoSalir.GUARDAR ) {
				JOptionPane.showMessageDialog( ventana , "Guardando" );
				ventana.setVisible( false );
				ventana.dispose( );
			} else if ( r == DialogoSalir.NO_GUARDAR ) {
				JOptionPane.showMessageDialog( ventana , "Sin guardar" );
				ventana.setVisible( false );
				ventana.dispose( );
			} else {
				JOptionPane.showMessageDialog( ventana , "Cancelar" );
			}
		}
	}

	@Override
	public void windowDeactivated ( WindowEvent e ) {
		
	}

	@Override
	public void windowDeiconified ( WindowEvent e ) {
		
	}

	@Override
	public void windowIconified ( WindowEvent e ) {
		
	}

	@Override
	public void windowOpened ( WindowEvent e ) {
		
	}
	
}
