package interfaz.grafico;

import java.util.Observable; //import java.awt.Dimension;
import java.util.Vector;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.event.ListDataEvent;

import java.awt.Color;
import java.awt.geom.Arc2D;

public class JGrafico extends JPanel implements java.util.Observer ,
		GraficoModelListener {

	/** serial version uid*/
	static final long	serialVersionUID	= 1;

	/* private boolean leyenda; Al hacer externa la leyenda, no es necesario. */

	GraficoModel		modelo;
	
	boolean desplazamiento = true;

	public JGrafico ( ) {
		super( );
		modelo = new AbstractGraficoModel( );
		modelo.addGraficoModelListener( this );
		// setPreferredSize(new java.awt.Dimension(100,100)); //??
		/* leyenda=true; Al hacer externa la leyenda, no es necesario. */

		// crear cuadro blanco:
		this.setBackground( Color.WHITE );
		this.setBorder( UIManager.getBorder( "TextField.border" ) );
		this.setOpaque( true );

		repaint( );
	}

	public JGrafico ( GraficoModel m ) {
		super( );
		modelo = m;
		modelo.addGraficoModelListener( this );
		// setPreferredSize(new java.awt.Dimension(100,100)); //??
		/* leyenda=true; Al hacer externa la leyenda, no es necesario. */

		// crear cuadro blanco:
		this.setBackground( Color.WHITE );
		this.setBorder( UIManager.getBorder( "TextField.border" ) );
		this.setOpaque( true );

		repaint( );
	}
	
	public void setDesplazamiento ( boolean d ) {
		desplazamiento = d;
	}

	public void paint ( Graphics g ) {
		super.paint( g );

		Graphics2D g2 = (Graphics2D) g;

		Double anchoTotal = new Double( this.getWidth( ) );
		Double largoTotal = new Double( this.getHeight( ) );

		Double insets = 5.0;

		int porcionesTotal = modelo.getSize( );

		Double espacioEntrePorciones = 0.0;
		if ( desplazamiento ) {
			espacioEntrePorciones = ( anchoTotal / 20.0 ); // 5%
		}

		/*
		 * System.out.println("posicion_x , posicion_y , anchoFigura , largoFigura => "
		 * + posicion_x + " , " + posicion_y + " , " + anchoFigura + " , " +
		 * largoFigura); System.out.println("anchoTotal, largoTotal => "+
		 * anchoTotal + " , " + largoTotal);
		 */

		if ( porcionesTotal > 0
				&& anchoTotal > ( insets * 2 + espacioEntrePorciones )
				&& largoTotal > ( insets * 2 /* + espacioEntrePorciones */) ) {
			// Crear la porciones.
			Double posicion_x , posicion_y;
			Double anchoFigura = anchoTotal - insets * 2
					- espacioEntrePorciones;
			Double largoFigura = 2.0 * ( largoTotal - insets * 2 /*- espacioEntrePorciones*/ );
			Double gradosInicial = 0.0;
			Double gradosExtension = 0.0;

			/*
			 * x: 5.0 puntos a la derecha de la esquina superior izquierda. y:
			 * 5.0 puntos abajo de la esquina superior izquierda.
			 */
			posicion_x = new Double( 0 + insets  + espacioEntrePorciones/2.0 );
			posicion_y = new Double( 0 + insets /* + espacioEntrePorciones/2.0 */);

			Double sumaTotal = modelo.getSum( );

			Vector < Arc2D.Double > tarta = new Vector < Arc2D.Double >(
					porcionesTotal );

			for ( int i = 0 ; i < porcionesTotal ; i++ ) {

				gradosExtension = modelo.getValueAt( i ) * 180.0 / sumaTotal;

				g2.setColor( modelo.getPorcionColor( i ) );

				Arc2D.Double porcion = new Arc2D.Double( posicion_x ,
						posicion_y , anchoFigura , largoFigura , gradosInicial ,
						gradosExtension , Arc2D.PIE );

				if ( desplazamiento && porcionesTotal > 1) {
					/*Double anguloMedio = gradosInicial
							+ ( gradosExtension - gradosInicial ) / 2.0;

					Double desplazar_x = Math.cos( anguloMedio * Math.PI / 180 )
							* espacioEntrePorciones;
*/
					Double desplazar_x = - espacioEntrePorciones / 2.0 + espacioEntrePorciones * ( porcionesTotal - 1 - i ) / ( porcionesTotal - 1 ) ;
					
					/*System.out.println( "x, y, ancho, largo, anchoT, largoT, inset, espacioS, desplazamiento => "
							+ posicion_x + ", " + posicion_y + ", " + anchoFigura + ", " + largoFigura + ", " + 
							anchoTotal + ", " + largoTotal + ", " + insets + ", " + espacioEntrePorciones + ", " + 
							desplazar_x );*/
					
					g2.translate( desplazar_x , 0.0 );

					g2.fill( porcion );
					g2.setColor( Color.BLACK );
					g2.draw( porcion );

					//pintar Cantidad
					
					g2.translate( -desplazar_x , 0.0 );

				} else {
					g2.fill( porcion );
					g2.setColor( Color.BLACK );
					g2.draw( porcion );
					
					//pintar Cantidad
				}

				gradosInicial += gradosExtension;

				tarta.add( porcion );
			}

		} else {
			/*g2.setColor( Color.BLACK );
			 posicion (0,0), el centro de la figura. 
			g2.fill( new Rectangle2D.Double( new Double( 0 ) , new Double( 0 ) ,
					anchoTotal , largoTotal ) );*/
		}

		/*
		 * int posicion_x,posicion_y,ancho,largo; Double gradosInicial=0.0;
		 * Double gradosExtension=0.0;
		 * 
		 * if( getWidth() > 10 && getHeight() > 10){ //Crear la
		 * semicircunferencia donde se verán los gráficos posicion_x=0;//era 3
		 * posicion_y=0;//era 3 ancho=getWidth();//era -6
		 * largo=getHeight();//era -6 gradosInicial=0.0; for( int i = 0 ; i <
		 * modelo.getSize(); i++ ) { gradosExtension = (Double)
		 * modelo.getValueAt( i ); gradosExtension = gradosExtension * 180.0 /
		 * modelo.getSum(); g.setColor( modelo.getPorcionColor( i ) );
		 * g.fillArc( posicion_x, posicion_y, ancho, largo,
		 * gradosInicial.intValue(), gradosExtension.intValue()); gradosInicial
		 * += gradosExtension; } } else { posicion_x = 0; posicion_y = 0; ancho
		 * = getWidth(); largo = getHeight(); g.setColor( Color.BLACK );
		 * g.fillRect( posicion_x, posicion_y, ancho, largo); }
		 */
	}

	/*
	 * public void setLeyenda( boolean leyenda ){ this.leyenda=leyenda; }
	 * 
	 * public boolean getLeyenda () { return leyenda; }Haciendo la leyenda algo
	 * externo, no es necesario.
	 */

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
	 */
	public void update ( Observable o , Object arg ) {
		// TODO Auto-generated method stub
		// se trata de actualizar el modelo respecto de los cambios hechos en la
		// vista.
		// como es de solo lectura, no hace falta.
		// Dejo este método así, aunque no se utilice para posibles futuras
		// ampliaciones.
	}

	public GraficoModel getModel ( ) {
		return modelo;
	}

	public void setModel ( GraficoModel m ) {
		modelo.removeGraficoModelListener( this );
		modelo = m;
		modelo.addGraficoModelListener( this );
		graphicChanged( new ListDataEvent( this , 0 , 0 , 0 ) );
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * interfaz.grafico.GraficoModelListener#tableChanged(javax.swing.event.
	 * ListDataEvent)
	 */
	public void graphicChanged ( ListDataEvent e ) {
		repaint( );
	}

	public static void main ( String [] args ) {
		GraficoModel moG = new AbstractGraficoModel( );
		JGrafico g = new JGrafico( moG );
		
		g.setDesplazamiento( true );

		moG.addValue( new Double( 3 ) , "uno" );
		moG.addValue( new Double( 4 ) , "dos" );
		moG.addValue( new Double(19 ) , "tres" );
		javax.swing.JPanel p = new javax.swing.JPanel( new java.awt.BorderLayout() );
		p.add( g , java.awt.BorderLayout.CENTER );
		javax.swing.JFrame v = new javax.swing.JFrame( );
		v.setContentPane( p );
		v.setDefaultCloseOperation( javax.swing.JFrame.EXIT_ON_CLOSE );
		v.setTitle( "Prueba Grafico" );
		v.pack( );
		v.setSize( 500 , 500 );
		v.setVisible( true );
	}
}
