/**
 * 
 */
package interfaz.semaforo;

import javax.swing.JLabel;
import java.lang.IllegalArgumentException;
import java.util.HashMap;
import java.util.ResourceBundle;

import javax.swing.ImageIcon;

/**
 * @author angel
 *
 */
public class JSemaforo extends JLabel {

	private static final long serialVersionUID = 1L;
	
	/**
	 * recursos de iconos etc...
	 */
	private static ResourceBundle recursos = ResourceBundle.getBundle("interfaz.Recursos");
	
	public final static int ROJO = 3;
	public final static int AMBAR = 2;
	public final static int VERDE = 1;
	public final static int DESCONOCIDO = 0;
	
	//en el fichero raiz del proyecto en una carpeta llamada interfaz.imagenes
	private final static ImageIcon [] iconos = {
			(ImageIcon) recursos.getObject("img_gris"), //desconocido = 0
			(ImageIcon) recursos.getObject("img_verde"), //verde = 1
			(ImageIcon) recursos.getObject("img_ambar"), //ambar = 2
			(ImageIcon) recursos.getObject("img_rojo") //rojo =3
	};
	private final static HashMap <Integer, ImageIcon>map = new HashMap<Integer,ImageIcon>();
	
	static {
		for (int i=0; i<4;i++){
			map.put( new Integer (i), iconos[i]);
		}

	}
	
	public int color = DESCONOCIDO;
	
	public JSemaforo () {
		super();
		loadColor();
		setColor(DESCONOCIDO);
	}
	
	public JSemaforo ( int colorInicial ) {
		super();
		loadColor();
		setColor(colorInicial);
	}
	
	public int getColor () {
		return color;
	}
	
	public boolean isAMBAR () {
		return (color == AMBAR);
	}
	
	public boolean isVERDE () {
		return (color == VERDE);
	}
	
	public boolean isROJO () {
		return (color == ROJO);
	}
	
	public boolean isDESCONOCIDO () {
		return (color == DESCONOCIDO);
	}
	
	private void loadColor () {
		this.setIcon(map.get(new Integer(color)));
	}
	
	public void setColor( int nuevoColor ) {
		if (nuevoColor < -1 || nuevoColor > 3) throw new IllegalArgumentException("nuevoColor must be ROJO, AMBAR, VERDE ó DESCONOCIDO");
		if (color != nuevoColor) {
			color = nuevoColor;
			loadColor();
		}
	}

	public void setAMBAR () {
		setColor(AMBAR);
	}
	
	public void setVERDE () {
		setColor(VERDE);
	}

	public void setROJO () {
		setColor(ROJO);
	}
	
	public void setDESCONOCIDO () {
		setColor(DESCONOCIDO);
	}

}
