package interfaz.vejecucion;

import java.awt.Component;
import java.util.ResourceBundle;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

public class DialogoNuevaEntrada extends JDialog {
	/** serial Version UID */
	private static final long	serialVersionUID	= -2201823396167528830L;
	/**
	 * recursos para dar soporte sobre idiomas
	 */
	ResourceBundle					idiomas				= ResourceBundle
																.getBundle( "interfaz.idiomas.Recursos" );
	/**
	 * recursos de iconos etc...
	 */
	ResourceBundle					recursos			= ResourceBundle
																.getBundle( "interfaz.Recursos" );

	public static int OK_OPTION = JOptionPane.OK_OPTION;

	private JTextField	txtNuevaEntrada = new JTextField(50);
	
	private String		cadbtnOK	= idiomas.getString( "eti_botOk" );
	private String		cadbtnCancelar	= idiomas.getString( "eti_botCancelar" );
	
	private String		titulo;
	
	public DialogoNuevaEntrada (  ) {

		super();
		
		this.titulo = ( idiomas.getString( "eti_titulo_dialogo_nuevaEntrada" ) );
		
		this.setResizable( true );
		
		setDefaultCloseOperation( HIDE_ON_CLOSE );
		
	}


	public int showDialog ( Component parent ) {
		// Create an array of the text and components to be displayed.
		String strNuevaEntrada = idiomas.getString( "eti_nuevaEntrada" );
		Object [] array = { strNuevaEntrada, txtNuevaEntrada };

		// Create an array specifying the number of dialog buttons
		// and their text.
		Object [] options = { cadbtnOK, cadbtnCancelar };

		// Create the JOptionPane.
		return JOptionPane.showOptionDialog( parent , array, titulo, JOptionPane.OK_CANCEL_OPTION ,
				JOptionPane.QUESTION_MESSAGE , null , options , options[0] );
	}
	
	public String getEntrada ( ) {
		return this.txtNuevaEntrada.getText( );
	}

}
