package interfaz.vestadisticas.fuenteanotado;

import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import modelo.modeloXML.FicheroAnotado;

public class NombreFicheroAnotadoCellRenderer extends JLabel implements ListCellRenderer {

	/** serial uid version. */
	private static final long serialVersionUID = -8324345797079244663L;


	public NombreFicheroAnotadoCellRenderer () {
		setOpaque(true);
        setHorizontalAlignment(CENTER);
        setVerticalAlignment(CENTER);

	}
	
	@Override
	public Component getListCellRendererComponent(
			JList list,
            Object value,
            int index,
            boolean isSelected,
            boolean cellHasFocus) {
		
		if ( value instanceof FicheroAnotado ) {
			FicheroAnotado f = (FicheroAnotado) value;
			
	        if (isSelected) {
	            setBackground(list.getSelectionBackground());
	            setForeground(list.getSelectionForeground());
	        } else {
	            setBackground(list.getBackground());
	            setForeground(list.getForeground());
	        }
	        
	        this.setText( f.getNombreFichero() );

		}
		
        return this;

	}
	
	
	/*
	 * Esta función sirve para obtener sólo el texto de este renderer.
	 * @see javax.swing.JLabel#getText()
	 */
	public String getRendereredText() {
		return this.getText( );
	}

}
