package interfaz.vestadisticas.grafollamadas;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.util.ResourceBundle;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

import negocio.PreferenciasSingleton;

public class TabFLLCellRenderer implements TableCellRenderer {


	static Integer				NOMBRE = new Integer (0);
	static Integer				ETPROPIO = new Integer (1);
	static Integer				ETHIJOS = new Integer(2);
	static Integer				LLAMADAS = new Integer (3);
	static Integer				INDICE = new Integer (4);
	static Integer				CICLO = new Integer (5);
	
	/** recursos para dar soporte sobre idiomas */
	ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	
	@Override
	public Component getTableCellRendererComponent ( JTable tabla ,
			Object valor , boolean seleccionado , boolean tieneElFoco ,
			int fila , int columna ) {
		
		Integer icolumna = new Integer( columna );
		JLabel resultado = new JLabel();

		
		if ( icolumna.equals( ETPROPIO ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			x.setForeground( Color.RED );
			if( !x.getText( ).equals( "" )) {
				/** Sólo 2 decimales */
				Double d = Double.parseDouble( x.getText( ) );
				//DecimalFormat formateador = new DecimalFormat("#,##0.00");
				//x.setText( formateador.format( d ) + " s" );
				x.setText( String.format( "%1$,8.2f s", d ) );
				//x.setText( x.getText( ) + " s" );
			} else {
				x.setText( idiomas.getString( "ttp_incertidumbre" ) );
			}
			x.setToolTipText( idiomas.getString( "ttp_etpropio" ) );
			resultado = x;
		}  else if ( icolumna.equals( ETHIJOS ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			x.setForeground( Color.RED );
			if( !x.getText( ).equals( "" )) {
				/** Sólo 2 decimales */
				Double d = Double.parseDouble( x.getText( ) );
				//DecimalFormat formateador = new DecimalFormat("#,##0.00");
				//x.setText( formateador.format( d ) + " s" );
				x.setText( String.format( "%1$,8.2f s", d ) );
				//x.setText( x.getText( ) + " s" );
			} else {
				x.setText( idiomas.getString( "ttp_incertidumbre" ) );
			}
			x.setToolTipText( idiomas.getString( "ttp_ethijos" ) );
			resultado = x;
		} else if ( icolumna.equals( LLAMADAS  ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			x.setToolTipText( idiomas.getString( "ttp_llamadas" ) );
			resultado = x;
		} else if ( icolumna.equals( INDICE ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ).deriveFont( Font.BOLD ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			x.setText( " [ " + x.getText() + " ] ");
			x.setToolTipText( idiomas.getString( "ttp_indice" ) );
			resultado = x;
		} else if ( icolumna.equals( CICLO ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ).deriveFont( Font.BOLD ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			if( !x.getText( ).equals( "" )) {
				x.setText( " < " + x.getText( ) + " > " );
			}
			x.setToolTipText( idiomas.getString( "ttp_ciclo" ) );
			resultado = x;
		}
		
		return resultado;
	}

}
