package interfaz.vgprof;

import interfaz.acciones.CrearYGestionarAcciones;
import interfaz.dialogos.error.DialogoError;
import interfaz.semaforo.JSemaforo;

import java.awt.Color;
import java.awt.Font;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import modelo.vgprof.ModeloGprof;
import negocio.PreferenciasSingleton;
import negocio.ejecutarOrdenes.InterfazOrdenes;
import net.miginfocom.swing.MigLayout;

public class JPanelGprof extends JPanel implements ChangeListener ,
		InterfazOrdenes {

	/** serial version uid*/
	private static final long serialVersionUID = 759911159280491446L;

	/** recursos para dar soporte sobre idiomas */
	static ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	/** recursos de iconos etc... */
	static ResourceBundle recursos = ResourceBundle.getBundle("interfaz.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	/** recursos de idiomas para errores */
	static ResourceBundle errores = ResourceBundle.getBundle("interfaz.errores.Errores", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	
	private JLabel				etiPrograma			= new JLabel(
															idiomas
																	.getString( "eti_programa" ) );
	private JTextField			txtPrograma			= new JTextField( );
	{
		txtPrograma.setEditable( false );
	}
	private JLabel				etiDatosEjecucion	= new JLabel(
															idiomas
																	.getString( "eti_datosEjecucion" ) );
	private JTextField			txtDatosEjecucion	= new JTextField( );
	{
		txtDatosEjecucion.setEditable( false );
	}

	private JLabel				etiCmd				= new JLabel(
															idiomas
																	.getString( "eti_comando_gprof" ) );

	private JTextField			txtCmd				= new JTextField( );
	{
		txtCmd.setEditable( false );
	}

	/*
	 * private JLabel etiFicheros = new JLabel( idiomas .getString(
	 * "eti_ficherosAnotacion" ) ); private JList lstFicheros = new JList(
	 * molstFicheros ); { lstFicheros .setSelectionMode(
	 * ListSelectionModel.MULTIPLE_INTERVAL_SELECTION ); }
	 */

	private JLabel				etiDir				= new JLabel(
															idiomas
																	.getString( "eti_directorioTrabajo" ) );
	private JTextField			txtDir				= new JTextField( );
	{
		txtDir.setEditable( false );
	}
	
	/*private JButton				botAñadir			= new JButton( );
	private JButton				botQuitar			= new JButton( );*/
	private JButton				botGprof			= new JButton( );
/*	private JButton				botTraducir			= new JButton( );
	private JButton				botNombrePrograma	= new JButton( );*/
	private JButton				botCambiarDT		= new JButton( );
	private JButton				botEditarPrograma		= new JButton( );
	private JButton				botEditarDatosEjecucion		= new JButton( );
	private JButton				botEditarComando	= new JButton( );
	
	/** Enlazar las etiquetas con las acciones: */
	{
		etiPrograma.setLabelFor( botEditarPrograma );
		etiDatosEjecucion.setLabelFor( botEditarDatosEjecucion );
		etiCmd.setLabelFor( botEditarComando );
		etiDir.setLabelFor( botCambiarDT );
	}
	private JLabel				etiStatus			= new JLabel(
			idiomas
					.getString( "eti_estado" ) );
	private JSemaforo			semStatus			= new JSemaforo( );

	private JLabel				etiSalida				= new JLabel(
			idiomas
					.getString( "eti_salidaGprof" ) );

	private JTextArea			atxSalida			= new JTextArea( );
	{
		atxSalida.setEditable( false );
		atxSalida.setBackground( Color.WHITE );// fondo negro
		atxSalida.setForeground( Color.BLUE );// letras blancas
		//atxSalida.setFont( atxSalida.getFont( ).deriveFont( Font.BOLD ) );// negritas
		atxSalida.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ).deriveFont( Font.BOLD ) );// negritas
		atxSalida.setLineWrap( true );
		atxSalida.setWrapStyleWord( true );
	}
	

	/************************ PROPIEDADES ***********************/
	private ModeloGprof			moGprof				= null;

	public JPanelGprof ( ModeloGprof mg ) {
		super( new MigLayout( "fill" ) );

		setModel( mg );
		crearComponentes( );
	}

	public JPanelGprof ( ) {
		super ( new MigLayout( "fill" ) );

		setModel( null );
		crearComponentes();
	}
	/************************ METODOS ***********************/
	public boolean isVacio () {
		return this.moGprof == null;
	}
	
	public void cambiarFuente ( Font f ) {
		atxSalida.setFont( f );
	}
	
	protected void setModel ( ModeloGprof mg ) {
		this.moGprof = mg;

		if ( this.moGprof != null ) {

			if ( this.moGprof.getDirectorioTrabajo( ) == null ) {
				if ( this.moGprof.getPrograma( ) != null ) {
					this.moGprof.setDirectorioTrabajo( this.moGprof
							.getPrograma( ).getParentFile( ) );
				} else {
					this.moGprof.setDirectorioTrabajo( 
							PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getWorkspaceGprof( ) ); // gprof
				}
			}
			this.moGprof.addChangeListener( this );
			/* this.lstFicheros.setModel( this.moGprof.getFicherosListModel( )); */
		}

		actualizarModel( );

	}

	public ModeloGprof getModel ( ) {
		return this.moGprof;
	}

	protected void crearComponentes ( ) {
		setBorder( new EtchedBorder( ) );
		setOpaque( true );

/*		// activar botones:
		{
			botAñadir.setHideActionText( true );
			botAñadir.setAction( CrearYGestionarAcciones.getInstance().getAccionAñadirFicherosAnotados( ) );

			botQuitar.setHideActionText( true );
			botQuitar.setAction( CrearYGestionarAcciones.getInstance().getAccionQuitarFicherosAnotados( ) );
			
		}
		
		// construir paneles superior e inferior:
		JPanel panelSuperior = new JPanel( new MigLayout( "fill" ) );

		panelSuperior.add( etiFicheros ,
				"wmin 50lp, growx, pushx, cell 0 0 2 1" );
		panelSuperior.add( botAñadir ,
				"gapbefore unrel, cell 1 1 1 2, flowy, top" );
		panelSuperior.add( new JScrollPane( lstFicheros ) ,
				"wmin 50lp, grow, push, cell 0 1 1 2" );
		panelSuperior.add( botQuitar , "gapbefore unrel, cell 1 1 1 2" );
*/
		{
			botGprof.setHideActionText( true );
			botGprof.setAction( CrearYGestionarAcciones.getInstance().getAccionGprof( ) );
			
			/*botTraducir.setHideActionText( true );
			botTraducir.setAction( CrearYGestionarAcciones.getInstance().getAccionTraducir( ) );
			
			botNombrePrograma.setHideActionText( true );
			botNombrePrograma.setAction( CrearYGestionarAcciones.getInstance().getAccionNombreEjecutable( ) );*/
			
			this.botCambiarDT.setAction( CrearYGestionarAcciones.getInstance().getAccionCambiarDirectorioTrabajoGprof( ) );
			this.botCambiarDT.setIcon( null );
			this.botCambiarDT.setText( "..." );
			
			this.botEditarPrograma.setAction( CrearYGestionarAcciones.getInstance().getAccionEditarProgramaGprof( ) );
			this.botEditarPrograma.setIcon( null );
			this.botEditarPrograma.setText( "..." );
			
			this.botEditarDatosEjecucion.setAction( CrearYGestionarAcciones.getInstance().getAccionEditarDatosEjecucionGprof( ) );
			this.botEditarDatosEjecucion.setIcon( null );
			this.botEditarDatosEjecucion.setText( "..." );
			//txtCmd.setAction( CrearYGestionarAcciones.getInstance().getAccionCambiarDirectorioTrabajoCompilacion( ) );
			//this.txtDir.setAction( CrearYGestionarAcciones.getInstance().getAccionEditarComandoCompilacion( ) );
			
			this.botEditarComando.setAction( CrearYGestionarAcciones.getInstance().getAccionEditarComandoGprof( ) );
			this.botEditarComando.setIcon( null );
			this.botEditarComando.setText( "..." );
		}

		/*JPanel panelInferior = new JPanel( new MigLayout( "fill" ) );*/

		JPanel pnlEstatus;
		{
			pnlEstatus = new JPanel( new MigLayout( ) );
			pnlEstatus.add( etiStatus , "wrap" );
			pnlEstatus.add( semStatus , "alignx center, aligny top" );
			pnlEstatus.setBorder( BorderFactory
					.createEtchedBorder( EtchedBorder.LOWERED ) );
		}
		this.add( pnlEstatus , "sizegroupy a, gapafter unrel, split 3" );
		
		JPanel pnlGprof;
		{
			pnlGprof = new JPanel ( new MigLayout() );
			pnlGprof.add( etiPrograma , "sgy Cmd");
			pnlGprof.add( txtPrograma , "growx,pushx,wmin 100pt, sgy Cmd" );
			pnlGprof.add( botEditarPrograma , "sgy Cmd, wrap" );
			pnlGprof.add( etiDatosEjecucion , "sgy Cmd");
			pnlGprof.add( txtDatosEjecucion , "growx,pushx,wmin 100pt, sgy Cmd" );
			pnlGprof.add( botEditarDatosEjecucion , "sgy Cmd, wrap" );
			pnlGprof.add( etiCmd , "sgy Cmd");
			/*pnlGprof.add( txtCmd , "growx,pushx,wmin 100pt, sgy Cmd, span, wrap" );*/
			pnlGprof.add( txtCmd , "growx,pushx,wmin 100pt, sgy Cmd" );
			pnlGprof.add( botEditarComando , "sgy Cmd, wrap" );
			pnlGprof.add( etiDir , "sgy Dir" );
			pnlGprof.add( txtDir , "growx,pushx,wmin 60pt, sgy Cmd" );
			pnlGprof.add( botCambiarDT , "sgy Cmd, wrap" );
			pnlGprof.setBorder( BorderFactory.createEtchedBorder( EtchedBorder.LOWERED ) );
		}
		this.add( pnlGprof , "growx, pushx, sizegroupy a" );
		this.add( botGprof , "gapbefore unrel, wrap" );
		/*panelInferior.add( botCompilar , "gapbefore unrel, split 2, flowy" );
		panelInferior.add( botNombrePrograma , "gapbefore unrel, wrap" );*/

		this.add( etiSalida , "wrap" );
		this.add( new JScrollPane( atxSalida ) , "span, grow" );

/*		JSplitPane panelDivide = new JSplitPane( JSplitPane.VERTICAL_SPLIT );
		panelDivide.setTopComponent( panelSuperior );
		panelDivide.setBottomComponent( panelInferior );
		panelDivide.setOneTouchExpandable( true );

		add( panelDivide , "grow" );*/

	}

	@Override
	public void empezarOrden ( String comando ) {
		if ( !isVacio( ) ) {
			semStatus.setAMBAR( );
			semStatus.setToolTipText( idiomas.getString( "eti_ejecutandoGprof" ) );
			this.atxSalida.setText( idiomas.getString( "eti_gprofInicio" )
					+ "\n" + this.txtCmd.getText( ) );

		}
	}
	
	@Override
	public void ordenErrorIndeterminado( String comando, File directorio, Exception e ){
		String saltoLinea = "\n";
		String descripcion;

		descripcion = errores.getString( "err_errorEjecuciónOrden" )
				+ saltoLinea + errores.getString( "err_errorEjecuciónOrden_orden" )
				+ saltoLinea + comando
				+ saltoLinea + errores.getString( "err_errorEjecución_directorio" )
				+ saltoLinea + directorio.getName( )
				+ saltoLinea
				+ saltoLinea + errores.getString( "err_detalles:" )
				+ saltoLinea + e.getMessage( );
		
		DialogoError.getInstance( ).showErrorDialog( descripcion );
	}

	@Override
	public void terminarOrden ( int devolverResultadoEjecución ,
			String salida, String error ) {
		if ( !isVacio( ) ) {
			if ( devolverResultadoEjecución == 0 ) {
				
				/** Hay un problema con un carácter &#12; que aparece 
				 * en la salida de gprof y hay que eliminarlo para que no 
				 * de problemas en los posteriores XML. */
				salida = salida.replace( "" , "\n" );
				
				this.atxSalida.setText( salida );
				this.moGprof.setSalida( salida );
				semStatus.setVERDE( );
				semStatus.setToolTipText( idiomas
						.getString( "eti_SalidaGprofExito" ) );
				try {
					File nuevoFicheroResultado = new File( moGprof
							.getDirectorioTrabajo( ) , moGprof
							.getNombreSalidaGprof( ) );
					if ( !nuevoFicheroResultado.exists( ) ) {
						if ( nuevoFicheroResultado.createNewFile( ) )
							DialogoError.getInstance().showInfoDialog(  
									errores.getString( "no-err_crearFichero" ) + nuevoFicheroResultado
									.getCanonicalPath( ) ); 
						else
							DialogoError.getInstance( ).showErrorDialog(  
									errores.getString( "err_crearFichero" ) + nuevoFicheroResultado
									.getCanonicalPath( ) );
					} else {
						/** hacer lo que toca después */
						if ( !nuevoFicheroResultado.delete( ) )
							DialogoError.getInstance( ).showErrorDialog(  
									errores.getString( "err_borrarFichero" ) + nuevoFicheroResultado
									.getAbsolutePath( ) );

						if ( nuevoFicheroResultado.createNewFile( ) )
							DialogoError.getInstance().showInfoDialog(  
									errores.getString( "no-err_crearFichero" ) + nuevoFicheroResultado
									.getAbsolutePath( ) ); 
						else
							DialogoError.getInstance( ).showErrorDialog( 
									errores.getString( "err_crearFichero" ) + nuevoFicheroResultado
									.getCanonicalPath( ) );
					}
					
					/** escribir la salida en el fichero salida */
					FileWriter escribirFichero = new FileWriter(
							nuevoFicheroResultado );
					BufferedWriter escribirBuffer = new BufferedWriter(
							escribirFichero );
					escribirBuffer.write( moGprof.getSalidaGprof( ) );
					escribirBuffer.close( );
					moGprof.setFicheroSalida( nuevoFicheroResultado );

				} catch ( IOException e ) {
					DialogoError.getInstance( ).showErrorDialog( 
							errores.getString( "err_io" ) );
					e.printStackTrace( );
				}

			} else {
				this.atxSalida.setText( idiomas
						.getString( "eti_gprofError" )
						+ "\n" + error );
				if ( error.contains( "No such file or directory" ) )
					DialogoError.getInstance( ).showErrorDialog( 
							errores.getString( "err_gprof-faltaprograma" ) );
				semStatus.setROJO( );
				semStatus.setToolTipText( idiomas
						.getString( "eti_SalidaGprofFracaso" ) );
			}
		}
	}

	@Override
	public void stateChanged ( ChangeEvent e ) {
		if ( e.getSource( ) instanceof ModeloGprof ) {
			this.actualizarModel( );
		}
		
		
	}
	
	private void actualizarModel ( ) {
		
		if( this.moGprof != null ) {
		/* txtDir */
		String directorioTrabajo = new String( "" );
		if ( this.moGprof.getDirectorioTrabajo( ) != null ) {
			try {
				directorioTrabajo = this.moGprof.getDirectorioTrabajo( )
						.getCanonicalPath( );
			} catch ( IOException e ) {
				e.printStackTrace( );
				directorioTrabajo = idiomas
						.getString( "eti_errorDirectorioTrabajo" );
			}
		}
		txtDir.setText( directorioTrabajo );

		/* txtCmd */
		String [] comp = this.moGprof.getComandoGprofAuto();
		String comps = new String( );
		for ( int i = 0 ; i < comp.length ; i ++ ) {
			comps += " " + comp[i];
		}
		comps.trim( );
		this.txtCmd.setText( comps );
		
		/* txtPrograma */
		String programa = new String( "" );
		if ( this.moGprof.getPrograma( ) != null ) {
			try {
				programa = this.moGprof.getPrograma( )
						.getCanonicalPath( );
			} catch ( IOException e ) {
				e.printStackTrace( );
				programa = idiomas
						.getString( "eti_errorNombrePrograma" );
			}
		}
		this.txtPrograma.setText( programa );
		
		/* txtDatosEjecucion */
		String datosEjecucion = new String( "" );
		if ( this.moGprof.getArchivoDatos( ) != null ) {
			try {
				datosEjecucion = this.moGprof.getArchivoDatos( )
						.getCanonicalPath( );
			} catch ( IOException e ) {
				e.printStackTrace( );
				datosEjecucion = idiomas
						.getString( "eti_errorNombreArchivoDatos" );
			}
		}
		this.txtDatosEjecucion.setText( datosEjecucion );

		/* lista ficheros fuente */
		
		if ( this.moGprof.getSalidaGprof() != null ) {
			this.atxSalida.setText( moGprof.getSalidaGprof() );
		}
		} else {
			/* txtDir */
			txtDir.setText( "" );

			/* txtCmd */
			this.txtCmd.setText( "" );
			
			/* txtPrograma */
			this.txtPrograma.setText( "" );
			
			/* txtDatosEjecucion */
			this.txtDatosEjecucion.setText( "" );

			/* lista ficheros fuente */
			this.atxSalida.setText( "" );
		}
	}
}
