package interfaz.vtraductor;


import interfaz.Vista;
import interfaz.acciones.CrearYGestionarAcciones;
import interfaz.acciones.InterfazCambiarDirectorioTrabajo;
import interfaz.acciones.InterfazCambiarNombre;
import interfaz.dialogos.dialogoAbrir.DialogoAbrir;
import interfaz.dialogos.dialogoCambiarComando.DialogoCambiarComando;
import interfaz.dialogos.dialogoDirectorio.JDirectoryChooser;
import interfaz.dialogos.error.DialogoError;

import java.awt.Component;
import java.awt.Font;
import java.awt.Frame;
import java.io.File;

import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import modelo.vgprof.ModeloGprof;
import modelo.vtraduccion.ModeloTR;
import negocio.PreferenciasSingleton;
import negocio.guigprof;
import negocio.ejecutarOrdenes.EjecutorComandos;
import net.miginfocom.swing.MigLayout;

/**
 * @author angel2
 *
 */
public class VistaTR  extends JPanel implements Vista, InterfazCambiarNombre, 
	InterfazCambiarDirectorioTrabajo {

	/** serial version uid*/
	private static final long	serialVersionUID	= -2388969297453026524L;

	/** Esta es la clase principal, ventana principal del interfaz o gui. */
	private Frame gui;

	/** recursos para dar soporte sobre idiomas */
	static ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	/** recursos de iconos etc... */
	static ResourceBundle recursos = ResourceBundle.getBundle("interfaz.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	/** recursos de idiomas para errores */
	static ResourceBundle errores = ResourceBundle.getBundle("interfaz.errores.Errores", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );

	/** dialogo Abrir **/ 
	DialogoAbrir					dialogoAbrir		= new DialogoAbrir( );
	
	/** barra de tareas específica de esta vista. */
	JToolBar barraDeTareas = new JToolBar();
	
	
	/**********Constructor PANEL Y GESTION PANEL***************/
	
	/**
	 * @param guIguigprof
	 */
	public VistaTR (Frame gui) {
		super(new MigLayout("fill"));
		this.gui = gui;
		idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos", PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale());
		crearPanel();
		crearBarraTareas();
	}

	/** Panel general de la vista compilación */
//	private JPanel panel;
	/** Panel de pestañas inferior, donde se muestra la salida de la compilación */
	private JTabbedPane	pestañas	= new JTabbedPane( );
	{
		ChangeListener cambioPestaña = new ChangeListener () {

			@Override
			public void stateChanged ( ChangeEvent arg0 ) {
				activarActions(visible);
			}
			
		};
		pestañas.addChangeListener( cambioPestaña );
	}

	protected void crearBarraTareas() {
		JButton botGenerarXML = new JButton ();
		{
			botGenerarXML.setHideActionText(true);
			botGenerarXML.setAction(CrearYGestionarAcciones.getInstance().getAccionGenerarXML () );
		}
		JButton botCerrar = new JButton ();
		{
			botCerrar.setHideActionText(true);
			botCerrar.setAction(CrearYGestionarAcciones.getInstance().getAccionCerrar());
		}
		JButton botTraducir = new JButton ();
		{
			botTraducir.setHideActionText(true);
			botTraducir.setAction(CrearYGestionarAcciones.getInstance().getAccionTraducir());
		}
		JButton botNombre = new JButton ();
		{
			botNombre.setHideActionText(true);
			botNombre.setAction( CrearYGestionarAcciones.getInstance().getAccionNombreXML( ) );
		}
		JButton botVerEstadisticas = new JButton ();
		{
			botVerEstadisticas.setHideActionText(true);
			botVerEstadisticas.setAction( CrearYGestionarAcciones.getInstance().getAccionVerEstadisticas( ) );
		}
		{
			barraDeTareas.setAutoscrolls(true);
			barraDeTareas.setFloatable(false);
			barraDeTareas.add(botGenerarXML);
			barraDeTareas.add( botCerrar );
			barraDeTareas.addSeparator( );
			barraDeTareas.add( botNombre );
			barraDeTareas.add( botTraducir );
			barraDeTareas.addSeparator( );
			barraDeTareas.add(botVerEstadisticas );
		}
	}

	/**
	 * @return
	 */
	public JToolBar getBarraDeTareas() {
		return barraDeTareas;
	}
	
	protected void crearPanel () {
		setOpaque(true);

		/** Se añade las pestañas. */
		add(pestañas, "grow");
		
		/** A continuación, se crea un panel inicial vacío. */
		pestañas.addTab( "" , new JPanelTR( null ) );
	}
	
	protected void añadirPestaña ( ModeloTR mt ) {
		/** nombre futura salida xml */
		if ( mt.getNombreXML( ) == null ) {
			String nombreSalidaTR;
			if ( mt.getFicheroSalida( ) != null ) {
				nombreSalidaTR = mt.getFicheroSalida( ).getName( );
			} else {
				nombreSalidaTR = idiomas.getString( "nombreEstandarTR" )
						+ "_"
						+ String.valueOf( pestañas.getComponentCount( ) );
			}
			mt.setNombreXML( nombreSalidaTR );
		}
		String nombreSalidaTR = mt.getNombreXML( );
		
		Icon icon = (Icon) recursos.getObject( "icn_TR" );
		
		JPanelTR pestañaNueva = new JPanelTR( mt );

		/** Crear la pestaña correctamente */
		pestañas.addTab(nombreSalidaTR, pestañaNueva);
		int index = pestañas.indexOfComponent(pestañaNueva);
		
		javax.swing.JLabel tabRenderer = new javax.swing.JLabel ( nombreSalidaTR );
		tabRenderer.setIcon(icon);
		tabRenderer.setIconTextGap(5);
		tabRenderer.setHorizontalTextPosition(SwingConstants.RIGHT);
		//tabRenderer.setToolTipText(camino);
				
		pestañas.setTabComponentAt(index, tabRenderer);
		pestañas.setToolTipTextAt(index, nombreSalidaTR);
		
		pestañas.setSelectedComponent(pestañaNueva);
	}
	
	/*********** métodos *************/
/*
	public String getNuevoNombre( ) {
		return idiomas.getString( "nombreEstandarCompilacion" ) + "_" + ( pestañas.getTabCount( ) + 1 );
	}*/
	
	public void cerrarPestañaActiva () {
		//		Programar un trabajo para el hilo de despacho
		final int indicePestañaActiva = pestañas.getSelectedIndex();
		if (indicePestañaActiva != -1 ) {
			String cuestión= new String(idiomas.getString("eti_tr_seguroCerrar"));
			String título= new String(idiomas.getString("eti_cerrar"));
			int está_usted_seguro= JOptionPane.showConfirmDialog(gui,
					cuestión,
					título,
					JOptionPane.YES_NO_OPTION);

			if(está_usted_seguro==JOptionPane.YES_OPTION){
				if( pestañas.getTabCount( ) > 1 ) {
					pestañas.removeTabAt(indicePestañaActiva);
				} else if( pestañas.getTabCount() == 1 ) {
					/*Component c = pestañas.getComponentAt( 0 );
					pestañas.setTitleAt( 0 , "" );
					pestañas.setIconAt( 0 , null );
					pestañas.setToolTipTextAt( 0 , null );
					if( c instanceof JPanelTR ) {
						( (JPanelTR) c).setModel( null );
						System.out.println("intentando cerrar");
					}*/
					pestañas.removeAll();
					pestañas.add( new JPanelTR ( ) );
				}
			}
		}
	}



	public void cerrarTodo ( ) {
		pestañas.removeAll( );
	}

	public void abrirSalidaEstandarTR ( ModeloTR mt ) {
		if ( mt != null ) {
			/** intentando crear una pestaña TR */
			
			if( pestañas.getTabCount( ) == 1 && pestañas.getComponentAt( 0 ) instanceof JPanelTR && ( (JPanelTR) pestañas.getComponentAt( 0 )).isVacio( ) ) {
					( (JPanelTR) pestañas.getComponentAt(0) ).setModel( mt );
				pestañas.removeAll();
				añadirPestaña( mt );

			} else {
				añadirPestaña( mt );

			}
		}
	}

	public void abrirSalidaEstandarTR ( ModeloGprof mg ) {
		File salida = mg.getFicheroSalida( );
		if ( salida != null && salida.exists( ) ) {
		
				ModeloTR mt = new ModeloTR( salida );
				mt.setDirectorioTrabajo( mg.getDirectorioTrabajo( ) );
				this.abrirSalidaEstandarTR( mt );
		} else {
			DialogoError.getInstance( ).showErrorDialog( 
				errores.getString( "err_abrirTraductor-no-salida" ) );
		}
	}

	
	public void abrirSalidaEstandarTR ( ) {
		File [] ficheros;
		/** Mostrar el dialogo de abrir (DialogoAbrir). */
		if ( dialogoAbrir.showOpenDialogGprof( guigprof.getInstance( ).getGUI( ), true ) == JFileChooser.APPROVE_OPTION ) {
			// *podría hacerlo para múltiples ficheros seleccionados...
			ficheros = dialogoAbrir.getSelectedFiles( );

			for ( int i = 0 ; i < ficheros.length ; i++ ) {

				/**
				 * Comprobar fichero seleccionado y abrir una nueva
				 * pestaña.
				 */
				if ( ficheros[i].exists() && ficheros[i].isFile( ) && ficheros[i].canRead( ) ) {
					ModeloTR mt = new ModeloTR( ficheros[i] );
					this.abrirSalidaEstandarTR( mt );
				} else {
					DialogoError.getInstance( ).showErrorDialog( 
							errores.getString("err_FicheroSalidaGprof") );
					
				}
			}
		}	
	}
	
	public void traducir ( ) {
		JPanelTR pt = getPanelActivo( );
		if ( pt != null ) {
			ModeloTR mt = pt.getModel( );
			if ( mt != null ) {
				final String [] orden = mt.getComandoTRAuto( );
				final File dirTrabajo = mt.getDirectorioTrabajo( );

				try {
					/** realizar traducción*/
					final Thread traductor = new EjecutorComandos( orden , dirTrabajo , pt );
					
					traductor.start( );
					
					/** hilo para actualizar botones cuando acabe la ejecución de traducción */
					new Thread() {
						public void run () {
							try {
								//System.out.println("tr hilo activar actions");
								traductor.join();
								
								//System.out.println( "traductor join() " );
								activarActions(visible);
								
							} catch ( InterruptedException e ) {
								DialogoError.getInstance( ).showErrorDialog( 
										errores.getString("err_errorTraduccion") );
								e.printStackTrace( );
							}
							
						}
					}.start( );
				} catch ( Exception e ) {

					DialogoError.getInstance( ).showErrorDialog( 
							errores.getString("err_errorTraduccion") );
				}
			}
											
		}
	}	
	
	/**
	 * Método para cambiar el fichero gprof en la pestaña activa.
	 */
	public void editarSalidaGprof ( File salida ) {
		ModeloTR mt = this.getModeloTRActivo( );
		if ( mt != null ) {
				mt.setFicheroSalida( salida );
				
				/** Ahora cambiamos el nombre. */
				String nombre = salida.getName( );
				nombre = nombre.substring( 0, 
						nombre.lastIndexOf( '.' ) );
				mt.setNombreXML( nombre );
				
				pestañas.setTitleAt( pestañas.indexOfComponent( getPanelActivo() ) , mt.getNombreXML( ) );
		}
	}
	
	public void editarSalidaGprof ( ) {
		File dir = this.getModeloTRActivo( ).getDirectorioTrabajo( );
		if ( dir != null) dialogoAbrir.setCurrentDirectory( dir );
		if( dialogoAbrir.showOpenDialogGprof( guigprof.getInstance( ).getGUI( ), false ) == JFileChooser.APPROVE_OPTION && dialogoAbrir.getSelectedFile( ) != null ) {
			this.editarSalidaGprof( dialogoAbrir.getSelectedFile( ) );	
		}

	}


	/**
	 * Método para cambiar el directorio de trabajo en la pestaña activa.
	 */
	public void cambiarDirectorioTrabajo ( ) {
		ModeloTR mg = this.getModeloTRActivo( );
		if ( mg != null ) {
			JDirectoryChooser dialogo = new JDirectoryChooser( new File( "/" ) );
			File directorio_inicial = mg.getDirectorioTrabajo( );
			if ( directorio_inicial != null ) {
				dialogo.setSelectedDirectory( directorio_inicial );
			}
			if ( dialogo.showDialog( gui ) == JDirectoryChooser.OK_OPTION ) {
				File directorio_final = dialogo.getSelectedDirectory( );
				if ( directorio_final != null && directorio_final.isDirectory( ) ) {
					mg.setDirectorioTrabajo( dialogo.getSelectedDirectory( ) );
				}
			}

		}
	}
	

	/**
	 * Método para editar el nombre del fichero XML
	 */
	public void cambiarNombre ( ) {
		/** editarNombreXML */
		JPanelTR pt = getPanelActivo();
		if ( pt != null ) {
				ModeloTR mt = pt.getModel( );

				if ( mt.getFicheroSalida( ) != null ) {
					if ( mt.getNombreXML( ) == null ) {
						mt.setNombreXML( mt.getFicheroSalida( ).getName( ) );
					}
					DialogoCambiarNombre dialogo = new DialogoCambiarNombre( mt.getNombreXML( ) );
					if( dialogo.showDialog( gui ) == DialogoCambiarNombre.OK_OPTION ) {
						String nombre = dialogo.getNombre();
						mt.setNombreXML( nombre );
						int index = pestañas.indexOfComponent( pt );
						
						pestañas.setTitleAt( index , nombre );
						( (javax.swing.JLabel)pestañas.getTabComponentAt( index ) ).setText(nombre);
						pestañas.setToolTipText( nombre );
					}
				}
		}
	}

	/**
	 * Método para editar el comando de traduccion 
	 */
	public void editarComando ( ) {
		JPanelTR pt = getPanelActivo();
		if ( pt != null ) {
				ModeloTR mo = pt.getModel( );
				DialogoCambiarComando diaOrdenes = new DialogoCambiarComando( 
						guigprof.getInstance( ).getGUI( ) );
				diaOrdenes.setComando( mo.getComandoTR( ) );

				boolean ordenModificada = diaOrdenes.showDialog( );
				
				Vector <String> orden = diaOrdenes.getComando();
				
				if ( ordenModificada && orden != null && orden.size( ) > 0 ) {
					
					mo.setComandoTR( orden );
					
				}

		}
	}
	public void cambiarFuente ( Font f ) {
		for (int i = 0; i < pestañas.getTabCount( ); i ++ ) {
			Component c = pestañas.getComponentAt( i );
			if( c instanceof JPanelTR ) {
				( ( JPanelTR ) c  ).cambiarFuente( f );
			}
		}
	}
	
	/******************* pestañas ***********************/
	
	public Vector < ModeloTR > getModelos () {
		Vector < ModeloTR > vModelos = new Vector < ModeloTR >();
		
		for (int i = 0; i < pestañas.getTabCount( ); i ++ ) {
			Component c = pestañas.getComponentAt( i );
			if( c instanceof JPanelTR ) {
				ModeloTR moT = ( ( JPanelTR ) c ).getModel( );
				if ( moT != null )
					vModelos.add( moT );
			}
		}
		
		return vModelos;
	}
	
	/** devuelve el modelo gprof del panel activo. Null si no hay ninguno; */
	public ModeloTR getModeloTRActivo() {
		ModeloTR mo = null;
		JPanelTR pc = getPanelActivo();
		if ( pc != null ) {
			mo = pc.getModel( );
		}
		return mo;
	}
	
	/** devuelve el panel activo. Null si no hay ninguno; */
	private JPanelTR getPanelActivo () {
		JPanelTR pc = null;
		if ( pestañas.getComponentCount() > 0 ) {
			Component c = pestañas.getSelectedComponent();
			if ( c instanceof JPanelTR ) {
				pc = (JPanelTR) c;
			}
		}
		return pc;
	}
	/****************Visibilidad********************/
	boolean visible = true;
	
	public void setActivo(boolean b){
		visible = b;
		setVisible(b);
		//también hay que anular las acciones que no correspondan.
		activarActions ( b );
		
		barraDeTareas.setEnabled(b);
		barraDeTareas.setVisible(b);
	}
	public boolean isActivo () {
		return visible;
	}
	public synchronized void activarActions ( boolean vistaActiva ) {		
		boolean panelNoVacio = false;
		boolean siguientePaso = false;
		if ( vistaActiva && this.getPanelActivo( ) != null && !this.getPanelActivo( )
				.isVacio( ) ) {
			panelNoVacio = true;
		}
		if ( panelNoVacio == true && this.getPanelActivo( ).getModel( ).istraducedToXML( ) ) {
			siguientePaso = true;
		}
		
		CrearYGestionarAcciones a = CrearYGestionarAcciones.getInstance( );
		
		a.activarActionsTR( vistaActiva, panelNoVacio , siguientePaso );
		
	}

}
