/**
 * 
 */
package modelo;

import java.awt.Font;
import java.awt.font.TextAttribute;
import java.io.File;
import java.util.Collection;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.Vector;

import javax.swing.UIManager;

import modelo.ficheros.TipoFichero;

/**
 * @author angel2
 *
 */
public class Preferencias implements Cloneable {

	private Boolean canonicalFileName = false;
	
		/** Directorio de usuario */
		private static File userDir = new File ( System.getProperty( "user.home" ) ); //"user.home" "user.dir"

	private File compilacionworkspace = null;
	private String compilador = new String("gcc");
	private String compiladorC = new String("gcc");
	private String compiladorCpp = new String("g++");
	private String compiladorFortran = new String("gfortran");
	private String compiladorPascal = new String("gpc");
	private String editor = new String("gedit");
	private String editorXML = new String( "firefox" );
	private File ejecucionworkspace = null;
	private Font estadisticasFont = UIManager.getFont("Table.font");
	private String gprof = new String("gprof");
	private File gprofworkspace = null;
	private Locale locale = new Locale("es","ES");
	private Vector <String> opcionesCompilador = new Vector <String> ();
	private Vector <String> opcionesCompiladorC = new Vector <String> ();
	private Vector <String> opcionesCompiladorCpp = new Vector <String> ();
	private Vector <String> opcionesCompiladorFortran = new Vector <String> ();
	private Vector <String> opcionesCompiladorPascal = new Vector <String> ();
	private Vector <String> opcionesGprof = new Vector <String> ();
	private Vector <String> opcionesTraductor = new Vector <String> ();
	
	 String strlookAndfeel = "Nimbus";
	//UIManager.getSystemLookAndFeelName( );
	
	/*	 String perl = new String("perl");
	 File traducctor = new File ( "tr-gprof-xml-2.2.pl/tr-gprof-xml.pl" );*/
	 String tr = new String ( "tr-gprof-xml" );
	
	 File traductorworkspace = null;
	

	
	 {
			opcionesCompilador.add( new String( "-pg" ) );
			opcionesCompilador.add( new String( "-fprofile" ) );
			opcionesCompilador.add( new String( "-g" ) );
			opcionesCompilador.add( new String( "-Wall" ) );
			opcionesCompilador.add( new String( "-pedantic" ) );
	}
	 {
			opcionesCompiladorC.add( new String( "-pg" ) );
			opcionesCompiladorC.add( new String( "-fprofile" ) );
			opcionesCompiladorC.add( new String( "-g" ) );
			opcionesCompiladorC.add( new String( "-Wall" ) );
			opcionesCompiladorC.add( new String( "-pedantic" ) );
	}
	 {
			opcionesCompiladorPascal.add( new String( "-pg" ) );
			opcionesCompiladorPascal.add( new String( "-fprofile" ) );
			opcionesCompiladorPascal.add( new String( "-g" ) );
			opcionesCompiladorPascal.add( new String( "-Wall" ) );
			opcionesCompiladorPascal.add( new String( "-pedantic" ) );
	}
	 {
			opcionesCompiladorCpp.add( new String( "-pg" ) );
			opcionesCompiladorCpp.add( new String( "-fprofile" ) );
			opcionesCompiladorCpp.add( new String( "-g" ) );
			opcionesCompiladorCpp.add( new String( "-Wall" ) );
			opcionesCompiladorCpp.add( new String( "-pedantic" ) );
	}
	 {
			opcionesCompiladorFortran.add( new String( "-pg" ) );
			opcionesCompiladorFortran.add( new String( "-fprofile" ) );
			opcionesCompiladorFortran.add( new String( "-g" ) );
			opcionesCompiladorFortran.add( new String( "-Wall" ) );
			opcionesCompiladorFortran.add( new String( "-pedantic" ) );
	}
	 {
			opcionesGprof.add( new String( "-p" ) );
			opcionesGprof.add( new String( "-q" ) );
			opcionesGprof.add( new String( "-C" ) );
			opcionesGprof.add( new String( "-i" ) );
			opcionesGprof.add( new String( "-A" ) );
			opcionesGprof.add( new String( "-x" ) );
		/*	opcionesGprof.add( new String( "-l" ) );*/ //línea a línea
	}
	 {
		/**
		 * añadir opciones del traductor por defecto, si corresponde.
		 */
		//opcionesTraductor.add( "-s" );
	}
	 {
		Map <TextAttribute, Object > textPropierties = new HashMap <TextAttribute, Object > ();
		textPropierties.put( TextAttribute.FAMILY , "Monospaced" );
		estadisticasFont = estadisticasFont.deriveFont(textPropierties);
	}
	
	public  boolean getUseCanonicalFileName ( ) {
		return canonicalFileName;
	}
	
	public void setUseCanonicalFileName ( boolean b ) {
		canonicalFileName = b;
	}
	
	public  Vector <String> getComandoC ( ) {
		Vector <String> comandoCompilar = new Vector <String> ();
		comandoCompilar.add( compiladorC );
		comandoCompilar.addAll( opcionesCompiladorC );
		return comandoCompilar;
	}
	
	public  Vector <String> getComandoCompilar() {
		Vector <String> comandoCompilar = new Vector <String> ();
		comandoCompilar.add( compilador );
		comandoCompilar.addAll( opcionesCompilador );
		return comandoCompilar;
	}
	
	public  Vector <String> getComandoCompilar( TipoFichero t ) {
		Vector <String> comandoCompilar;
		switch (t) {
		case C: 
			comandoCompilar = this.getComandoC(  );
			break;
		case CPP:
			comandoCompilar = this.getComandoCpp( );
			break;
		case PASCAL: 
			comandoCompilar = this.getComandoPascal( );
			break;
		case FORTRAN:
			comandoCompilar = this.getComandoFortran( );
			break;
		default:
			comandoCompilar = this.getComandoCompilar( );
		}

		return comandoCompilar;
	}

	public  Vector <String> getComandoCpp ( ) {
		Vector <String> comandoCompilar = new Vector <String> ();
		comandoCompilar.add( compiladorCpp );
		comandoCompilar.addAll( opcionesCompiladorCpp );
		return comandoCompilar;
	}
	
	public  Vector <String> getComandoFortran ( ) {
		Vector <String> comandoCompilar = new Vector <String> ();
		comandoCompilar.add( compiladorFortran );
		comandoCompilar.addAll( opcionesCompiladorFortran );
		return comandoCompilar;
	}

	public  Vector < String > getComandoGprof ( ) {
		Vector <String> comandoGprof = new Vector <String> ();
		comandoGprof.add( gprof );
		comandoGprof.addAll( opcionesGprof );
		return comandoGprof;
	}
	
	public  Vector <String> getComandoPascal ( ) {
		Vector <String> comandoCompilar = new Vector <String> ();
		comandoCompilar.add( compiladorPascal );
		comandoCompilar.addAll( opcionesCompiladorPascal );
		return comandoCompilar;
	}
	
	public  Vector < String > getComandoTraductor ( ) {
		Vector <String> comandoTR = new Vector <String> ();
		comandoTR.add( tr );
		comandoTR.addAll( opcionesTraductor );
		return comandoTR;
	}

	public  String getCompilador () {
		return compilador;
	}

	public  String getCompilador ( TipoFichero t ) {
		String c = null;
		switch (t) {
		case C: 	c = compiladorC; break;
		case CPP:	c = compiladorCpp; break;
		case FORTRAN:	c = compiladorFortran; break;
		case PASCAL:	c = compiladorPascal; break;
		default: c = null; break;
		}
		return c;
	}
	
	public  String getEditor() {
		return editor;
	}
	
	public  String getEditorXML ( ) {
		return editorXML;
	}

	public  Font getEstadisticasFont ( ) {
		return estadisticasFont;
	}
	
	public  Locale getLocale() {
		return locale;
	}
	
	public  String getLookAndFeelName ( ) {
		return strlookAndfeel;
	}
	
	public  Vector <String> getOpcionesCompilador () {
		return opcionesCompilador;
	}
	
	public  Vector <String> getOpcionesCompilador ( TipoFichero t ) {
		Vector <String> v = null;
		switch (t) {
		case C: 	v = opcionesCompiladorC; break;
		case CPP:	v = opcionesCompiladorCpp; break;
		case FORTRAN:	v = opcionesCompiladorFortran; break;
		case PASCAL:	v = opcionesCompiladorPascal; break;
		default: v = null; break;
		}
		return v;
	}
	
	public  Vector <String> getOpcionesGprof ( ) {
		return opcionesGprof;
	}
	
	public  Vector <String> getOpcionesTR ( ) {
		return opcionesTraductor;
	}
	
	public  String getTR ( ) {
		return tr;
	}
	
	public  File getWorkspaceCompilacion ( ) {
		if ( compilacionworkspace == null )
			compilacionworkspace = getWorkspaceDefecto();
		return compilacionworkspace;
	}

	public  File getWorkspaceDefecto () {
		return userDir;
	}
	
	public  File getWorkspaceEjecucion ( ) {
		if ( ejecucionworkspace == null )
			ejecucionworkspace = getWorkspaceDefecto();
		return ejecucionworkspace;
	}
	
	public  File getWorkspaceGprof ( ) {
		if ( gprofworkspace == null )
			gprofworkspace = getWorkspaceDefecto();
		return gprofworkspace;
	}
	
	public  File getWorkspaceTR ( ) {
		if ( traductorworkspace == null )
			traductorworkspace = getWorkspaceDefecto();
		return traductorworkspace;
	}
		


	public  void setCompilador ( String s ) {
		if( s != null && s.compareTo( "" )!= 0 )
			compilador = s;
	}

	public  void setCompilador ( String s, TipoFichero t ) {
		if( s != null && s.compareTo( "" )!= 0 )
			switch (t) {
			case C: 	compiladorC = s; break;
			case CPP:	compiladorCpp = s; break;
			case FORTRAN:	compiladorFortran = s; break;
			case PASCAL:	compiladorPascal = s; break;
			default: break;
			}
	}
	
	public  void setEditor(String e) {
		if( e != null && !e.isEmpty( ) )
			editor = e;
	}

	public  void setEditorXML (String e) {
		if( e != null && !e.isEmpty( ) )
			editorXML = e;
	}
	
	public  void setEstadisticasFont(Font f ) {
		if ( f != null)
			estadisticasFont = f;
	}
	
	public  void setLocale( Locale l) {
		locale = l;
	}
	
	public  void setLookAndFeelName ( String lafElegido ) {
		if ( lafElegido != null )
			strlookAndfeel = lafElegido;		
	}
	
	public  void setOpcionesCompilador ( Collection <String> cs ) {
		if ( cs != null )
			opcionesCompilador = new Vector <String> ( cs );
	}
	
	public  void setOpcionesCompilador ( Collection <String> cs, TipoFichero t ) {
		if ( cs != null ) 
			switch (t) {
			case C: 	opcionesCompiladorC = new Vector <String> ( cs ); break;
			case CPP:	opcionesCompiladorCpp = new Vector <String> ( cs ); break;
			case FORTRAN:	opcionesCompiladorFortran = new Vector <String> ( cs ); break;
			case PASCAL:	opcionesCompiladorPascal = new Vector <String> ( cs ); break;
			default: break;
			}
		
		
	}
		
	public  void setOpcionesGprof ( Collection <String> cs ) {
		if( cs != null )
			opcionesGprof = new Vector <String> ( cs );
	}
	
	public  void setOpcionesTR ( Collection <String> cs ) {
		if ( cs != null )
			opcionesTraductor = new Vector <String> ( cs );
	}

	public  void setTR ( String traductor ) {
		if( traductor != null && !traductor.isEmpty( ) )
			tr = traductor;
	}
	
	public  void setWorkspaceCompilacion ( File ws ) {
		if ( ws != null && ws.isDirectory( ) )
			compilacionworkspace = ws;
	}

	public  void setWorkspaceDefecto ( File f ) {
		if ( f != null && f.isDirectory( ) )
			userDir = f;
	}

	public  void setWorkspaceEjecucion ( File ws ) {
		if ( ws != null && ws.isDirectory( ) )
			ejecucionworkspace = ws;
	}
	
	public  void setWorkspaceGprof ( File ws ) {
		if ( ws != null && ws.isDirectory( ) )
			gprofworkspace = ws;
	}
	
	public  void setWorkspaceTR ( File ws ) {
		if ( ws != null && ws.isDirectory( ) )
			traductorworkspace = ws;
	}
	
	@SuppressWarnings ( "unchecked" )
	public Object clone(){
		Preferencias obj = null;
	    try{
	    	obj= (Preferencias) super.clone();
	    }catch(CloneNotSupportedException ex){
	    	System.out.println(" no se puede duplicar");
	    }
	    
	    obj.locale = (Locale) locale.clone();
		obj.opcionesCompilador = ( Vector <String> ) opcionesCompilador.clone( );
		obj.opcionesCompiladorC = ( Vector <String> ) opcionesCompiladorC.clone( );
		obj.opcionesCompiladorCpp = ( Vector <String> ) opcionesCompiladorCpp.clone( );
		obj.opcionesCompiladorFortran = ( Vector <String> ) opcionesCompiladorFortran.clone( );
		obj.opcionesCompiladorPascal = ( Vector <String> ) opcionesCompiladorPascal.clone( );
		obj.opcionesGprof = ( Vector <String> ) opcionesGprof.clone( );
		obj.opcionesTraductor = ( Vector <String> ) opcionesTraductor.clone( );
		
		return obj;
	}

	
	public String toString() {
		String cad = new String();
		
		cad += getEditor( ) + "\n";
		cad += getComandoCompilar( ).toString( ) + "\n";
		cad += this.getComandoCompilar( TipoFichero.C ).toString( ) + "\n";
		cad += this.getComandoCompilar( TipoFichero.CPP ).toString( ) + "\n";
		cad += this.getComandoCompilar( TipoFichero.FORTRAN ).toString( ) + "\n";
		cad += this.getComandoCompilar( TipoFichero.PASCAL ).toString( ) + "\n";
		cad += getComandoGprof( ).toString( ) + "\n";
		cad += getComandoTraductor( ).toString( ) + "\n";
		cad += getLookAndFeelName( ).toString( ) + "\n";
		cad += getWorkspaceDefecto( ).toString( ) + "\n";
		cad += getWorkspaceCompilacion( ).toString( ) + "\n";
		cad += getWorkspaceEjecucion( ).toString() + "\n";
		cad += getWorkspaceGprof( ).toString() + "\n";
		cad += getWorkspaceTR( ).toString( ) + "\n";
		
		
		cad += this.getCompilador( ).toString( ) + "\n";
		cad += this.getCompilador( TipoFichero.C ).toString( ) + "\n";
		cad += this.getCompilador( TipoFichero.CPP ).toString( ) + "\n";
		cad += this.getCompilador( TipoFichero.FORTRAN ).toString( ) + "\n";
		cad += this.getCompilador( TipoFichero.PASCAL ).toString( ) + "\n";
		cad += this.getEditor( ).toString( ) + "\n";
		cad += this.getEditorXML().toString( ) + "\n";
		cad += this.getEstadisticasFont( ).toString( ) + "\n";
		cad += this.getLocale( ).toString( ) + "\n";
		cad += this.getOpcionesCompilador( ).toString( ) + "\n";
		cad += this.getOpcionesCompilador ( TipoFichero.C ).toString( ) + "\n";
		cad += this.getOpcionesCompilador ( TipoFichero.CPP ).toString( ) + "\n";
		cad += this.getOpcionesCompilador ( TipoFichero.PASCAL ).toString( ) + "\n";
		cad += this.getOpcionesCompilador ( TipoFichero.FORTRAN ).toString( ) + "\n";
		cad += this.getOpcionesGprof( ).toString( ) + "\n";
		cad += this.getOpcionesTR( ).toString( ) + "\n";
		
		return cad;
	}
	
	public  void main(String[] args) {
		Preferencias x = new Preferencias();
		
		System.out.println( x.toString( ) );
		
		Preferencias y = (Preferencias) x.clone( );
		
		System.out.println( y.toString( ) );
		
		y.setOpcionesCompilador( new Vector <String> (), TipoFichero.C );
		
		System.out.println( x.toString( ) );
		System.out.println( y.toString( ) );
		
		
	}
}
