package modelo.modeloXML;

import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

public class Ciclo {

	Integer indice;
	
	Integer ciclo;
	
	Integer totalLlamadasEntreMiembros = null;
	Integer numeroLlamadas = null;
	Integer numeroLlamadasRecursivas = null;
	Double tiempoPropio = null;
	Double tiempoHijos = null;

	Vector < EntradaFuncion > miembrosCiclo = new Vector < EntradaFuncion > ();	

	//todavía no sé si darle la función. Si se hace una consulta de los datos, ya no se puede seguir introduciendo
	//información. Pero habría que hacer un throw.
	//boolean consulta = false;
	
	
	
	
	public Integer getIndice ( ) {
		return indice;
	}
	
	public Integer getCiclo ( ) {
		return ciclo;
	}
	
	//Vector < EntradaFuncion > padres = new Vector < EntradaFuncion > ();
	//Vector < EntradaFuncion> hijos = new Vector < EntradaFuncion > (); 
	

	public Double getTiempoPropio () {
		if ( tiempoPropio == null ) {
			Double tiempo = new Double( 0 );
			Iterator < EntradaFuncion > it = this.miembrosCiclo.iterator();
			while (it.hasNext()) {
				EntradaFuncion  e = it.next();
				tiempo = tiempo + e.getTiempoPropio();
			}
			tiempoPropio = tiempo;
		}
		return tiempoPropio;
	}
	
	public Double getTiempoHijos () {
		if ( tiempoHijos == null ) {
			Double tiempo = new Double( 0 );
			Iterator < EntradaFuncion > it = this.miembrosCiclo.iterator();
			while (it.hasNext()) {
				EntradaFuncion  e = it.next();
				tiempo = tiempo + e.getTiempoHijos();
			}
			tiempoHijos = tiempo;
		}
		
		return tiempoHijos;
	}
	
	public Double getTiempoPropioMiembro ( EntradaFuncion miembro ) {
		return miembrosCiclo.contains(miembro) ? miembro.getTiempoPropio() : null;
	}
	
	public Double getTiempoHijosMiembro ( EntradaFuncion miembro ) {
		return miembrosCiclo.contains(miembro) ? miembro.getTiempoHijos() : null;
	}
	
	public Integer getNumeroLlamadas () {
		if ( numeroLlamadas == null) {
			Integer totalNumeroLlamadas = new Integer( 0 );
			Iterator < EntradaFuncion > it = this.getPadres( ).iterator();
			while (it.hasNext()) {
				EntradaFuncion  e = it.next();
				
				totalNumeroLlamadas += this.getNumeroLlamadasPadre( e );
			}
			numeroLlamadas = totalNumeroLlamadas;
		}
		
		return numeroLlamadas;	
	}
	
	public Integer getNumeroLlamadasRecursivas () {
		if ( numeroLlamadasRecursivas == null ) {
			Integer totalLlamadasRecursivasSimples = new Integer(0);
			Iterator < EntradaFuncion > recursividadMiembros = this.miembrosCiclo.iterator();
			while (recursividadMiembros.hasNext()) {
				EntradaFuncion  e = recursividadMiembros.next();
				totalLlamadasRecursivasSimples += e.getNumeroLlamadasRecursivas();
			}
			
			if ( totalLlamadasEntreMiembros == null ) {
				totalLlamadasEntreMiembros = llamadasEntreMiembros();
			}
			
			numeroLlamadasRecursivas = totalLlamadasRecursivasSimples + totalLlamadasEntreMiembros;
			
		}

		return numeroLlamadasRecursivas;	
	}
	
	private Integer llamadasEntreMiembros () {
		totalLlamadasEntreMiembros = new Integer(0);
		Iterator < EntradaFuncion > it = this.miembrosCiclo.iterator();
		while ( it.hasNext() ) {
			EntradaFuncion miembro = it.next();
			Iterator < EntradaFuncion > jt = this.miembrosCiclo.iterator();
			while ( jt.hasNext() ) {
				EntradaFuncion otroMiembro = jt.next();
				Integer llamadaEntreMiembros = miembro.getNumeroLlamadasHijo(otroMiembro);
				/** si existen esas llamadas, sumarlas. */
				if ( llamadaEntreMiembros != null ) totalLlamadasEntreMiembros += llamadaEntreMiembros.intValue();
			}
		}
		
		return totalLlamadasEntreMiembros;
	}
	
	// Es más difícil de lo que parece. No puedo guardar padres e hijos a la ligera. Porque si no, no sé de donde viene :S
	public Integer getNumeroLlamadasPadre ( EntradaFuncion padre ) {
		Integer numeroLlamadasPadre = new Integer ( 0 );
		
		Iterator < EntradaFuncion > it = this.getMiembros( ).iterator();
		while ( it.hasNext( ) ) {
			EntradaFuncion  miembro = it.next();
			
			if ( miembro.getPadres( ).contains( padre ) || miembro.getPadresMiembroCiclo( ).contains( padre ) )
				numeroLlamadasPadre += padre.getNumeroLlamadasHijo( miembro );
		}
		
		return numeroLlamadasPadre;
	}
	
	public Integer getNumeroLlamadasHijo ( EntradaFuncion hijo ) {
		Integer numeroLlamadasHijo = new Integer ( 0 );
		
		Iterator < EntradaFuncion > it = this.getMiembros( ).iterator();
		while ( it.hasNext( ) ) {
			EntradaFuncion  miembro = it.next();
			
			if ( miembro.getHijos().contains( hijo ) || miembro.getHijosMiembroCiclo( ).contains( hijo ) )
				numeroLlamadasHijo += miembro.getNumeroLlamadasHijo( hijo );
		}
		
		return numeroLlamadasHijo;
	}
	
	/* tengo que realizar las comprobaciones de que realmente es esto. */
	public Double getEstimacionTiempoPropioHijo ( EntradaFuncion hijo ) {
		Double estimacion = null;
		
		Iterator < EntradaFuncion > it = this.getMiembros( ).iterator();
		while ( it.hasNext( ) ) {
			EntradaFuncion  miembro = it.next();
			
			if ( miembro.getHijos().contains( hijo ) ) {
				if ( estimacion == null ) {
					estimacion = new Double ( 0.0 );
					estimacion += hijo.getEstimacionTiempoPropioPadre( miembro );
				}
				else
					estimacion += hijo.getEstimacionTiempoPropioPadre( miembro );
			}
		}
			
		return estimacion;
	}
	
	public Double getEstimacionTiempoHijosHijo ( EntradaFuncion hijo ) {
		Double estimacion = null;
		
		Iterator < EntradaFuncion > it = this.getMiembros( ).iterator();
		while ( it.hasNext( ) ) {
			EntradaFuncion  miembro = it.next();
			
			if ( miembro.getHijos().contains( hijo ) ) {
				if ( estimacion == null ) {
					estimacion = new Double ( 0.0 );
					estimacion += hijo.getEstimacionTiempoHijosPadre( miembro );
				}
				else
					estimacion += hijo.getEstimacionTiempoHijosPadre( miembro );
			}
		}
			
		return estimacion;
	}
	
	public Double getEstimacionTiempoPropioPadre ( EntradaFuncion padre ) {
		Double estimacion = null;
		
		/**la estimación del tiempo propio del padre, es el tiempo propio 
		de esta funcion, dividido por el número de 
		llamadas recibidas por esta función, multiplicada por el número 
		de llamadas que realiza la 
		función padre a esta función.*/
		
		Integer llamadasAMiembro = new Integer ( 0 );
		
		Iterator < EntradaFuncion > it = this.getMiembros( ).iterator();
		while ( it.hasNext( ) ) {
			EntradaFuncion  miembro = it.next();
			
			if ( miembro.getPadres().contains( padre ) ) {
				llamadasAMiembro += padre.getNumeroLlamadasHijo( padre );
			}
		}
		
		if ( this.getPadres().contains( padre ) ) {
				estimacion = new Double ( 0.0 );
				estimacion = this.getTiempoPropio( ) / 
				this.getNumeroLlamadas( ) * llamadasAMiembro;
		}
		
		return estimacion;
	}
	
	
	public Double getEstimacionTiempoHijosPadre ( EntradaFuncion padre ) {
		Double estimacion = null;
		
		/** la estimación del tiempo en hijos del padre, 
		es el tiempo en hijos propio de esta funcion, dividido por el número de 
		llamadas recibidas por esta función, multiplicada por 
		el número de llamadas que realiza la 
		función padre a esta función. */
				
		Integer llamadasAMiembro = new Integer ( 0 );
		
		Iterator < EntradaFuncion > it = this.getMiembros( ).iterator();
		while ( it.hasNext( ) ) {
			EntradaFuncion  miembro = it.next();
			
			if ( miembro.getPadres().contains( padre ) ) {
				llamadasAMiembro += padre.getNumeroLlamadasHijo( padre );
			}
		}
		
		if ( this.getPadres().contains( padre ) ) {
				estimacion = new Double ( 0.0 );
				estimacion = this.getTiempoHijos( ) / 
				this.getNumeroLlamadas( ) * llamadasAMiembro;
		}
		
		return estimacion;
	}
	
	public Collection < EntradaFuncion > getMiembros () {
		return this.miembrosCiclo;
	}
	
	public Collection < EntradaFuncion > getHijos () {
		Vector < EntradaFuncion > hijos = new Vector < EntradaFuncion > ( 0 );
		
		Iterator < EntradaFuncion > it = this.getMiembros( ).iterator();
		while ( it.hasNext( ) ) {
			EntradaFuncion  miembro = it.next();
			
			Iterator < EntradaFuncion > jt = miembro.getHijos( ).iterator( );
			while ( jt.hasNext( ) ) {
				EntradaFuncion e = jt.next( );
				
				if ( !hijos.contains( e ) )
					hijos.add( e );
			}
		}
		return hijos;
	}
	
	public Collection < EntradaFuncion > getPadres () {
		Vector < EntradaFuncion > padres = new Vector < EntradaFuncion > ( 0 );

		Iterator < EntradaFuncion > it = this.getMiembros( ).iterator();
		while ( it.hasNext( ) ) {
			EntradaFuncion  miembro = it.next();
			
			Iterator < EntradaFuncion > jt = miembro.getPadres( ).iterator( );
			while ( jt.hasNext( ) ) {
				EntradaFuncion e = jt.next( );
				
				if ( !padres.contains( e ) )
					padres.add( e );
			}
		}
		
		return padres;
	}
	
	public void setIndice ( Integer indice ) {
		this.indice = indice;
	}
	
	public void setCiclo ( Integer ciclo ) {
		this.ciclo = ciclo;
	}
	
	//para que funcione bien, el miembro que se introduce, debe ser una EntradaFuncion
	//completa. Todos los datos que se le agreguen a la EntradaFuncion miembro después,
	//no serán tenidos en cuenta en el ciclo.
	public void addMiembro ( EntradaFuncion miembro ) {
		if( !miembrosCiclo.contains( miembro )) {
			this.miembrosCiclo.add( miembro );
//			this.addPadresEHijosMiembro ( miembro );
//			hijos.addAll( miembro.getHijos() );
//			padres.addAll( miembro.getPadres() );
		}
	}
	
	//para que funcione bien, el miembro que se introduce, debe ser una EntradaFuncion
	//completa. Todos los datos que se le agreguen a la EntradaFuncion miembro después,
	//no serán tenidos en cuenta en el ciclo.
	public void setMiembros ( Collection < EntradaFuncion > miembrosCiclo ) {
		this.miembrosCiclo = new Vector < EntradaFuncion > (miembrosCiclo);
		
		//replicar en los miembros:
		Iterator < EntradaFuncion > it = this.miembrosCiclo.iterator();
		while (it.hasNext()) {
			EntradaFuncion  e = it.next();
//			this.addPadresEHijosMiembro ( e );
//			hijos.addAll( e.getHijos() );
//			padres.addAll( e.getPadres() );
			e.setCiclo( this );
		}
	}
	
/*	private void addPadresEHijosMiembro ( EntradaFuncion e ) {
		
	}
	
	private boolean isPadreCiclo ( EntradaFuncion e ) {
		boolean notfound = true;
		
		Iterator < EntradaFuncion > it = this.getMiembros( ).iterator();
		while ( it.hasNext( ) && notfound ) {
			EntradaFuncion  miembro = it.next();
			
			if ( miembro.getPadres( ).contains( e ) )
				notfound = false;
		}
		boolean isPadreCiclo = !notfound;
		
		return isPadreCiclo;
	}
	
	private Vector < EntradaFuncion > getHijoCiclo ( EntradaFuncion e ) {
		
	}
*/	
	public String toString () {
		String resultado;
		resultado = getIndice() + " - cycle " + getCiclo() + "\t " + getTiempoPropio() + "\t " + getTiempoHijos() + "\t " + getNumeroLlamadas() + "+" + getNumeroLlamadasRecursivas() + "\n";
		Iterator <EntradaFuncion> i = miembrosCiclo.iterator();
		while( i.hasNext() ) {
			EntradaFuncion e = i.next();
			resultado += " -> " + e.getIndice() + "\t " + e.getTiempoPropio() + "\t " + e.getTiempoHijos() + "\t " + e.getNumeroLlamadas() + "+" + e.getNumeroLlamadasRecursivas() + "\t " + e.getNombreFuncion() + "\n";
		}
		resultado += "\n";
		return resultado;
	}

	public Double getPorcentajeLlamadas ( EntradaFuncion f ) {
		// TODO Auto-generated method stub
		return new Double( 0.0 );
	}

	public Double getPorcentajeLlamadoras ( EntradaFuncion f ) {
		// TODO Auto-generated method stub
		return new Double( 0.0 );
	}

}
