package modelo.vestadisticas;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import modelo.modeloXML.ModeloXML;

public class ModeloEstadistica {

	File xml = null;
	
	ModeloXML mo = null;

	ArrayList < ChangeListener >	listeners			= new ArrayList < ChangeListener >( 0 ); // listeners

	
	public void addChangeListener ( ChangeListener listener ) {
		listeners.add( listener );
	}

	public void removeChangeListener ( ChangeListener listener ) {
		listeners.remove( listener );
	}

	private void OnChange ( ) {
		ChangeEvent e = new ChangeEvent( this );
		Iterator < ChangeListener > it = listeners.iterator( );
		while ( it.hasNext( ) ) {
			it.next( ).stateChanged( e );
		}
	}
	
	public void setFicheroXML ( File xml ) {
		this.xml = xml;
		
		OnChange();
	}
	
	public File getFicheroXML () {
		return xml;
	}

	public void setModeloXML ( ModeloXML x ) {
		this.mo = x;
		OnChange();
	}
	
	public ModeloXML getModeloXML () {
		return mo;
	}

	public boolean hasPerfilPlano ( ) {
		return mo != null ? mo.hasPerfilPlano( ) : false;
	}

	public boolean hasGrafoLlamadas ( ) {
		return mo != null ? mo.hasGrafoLlamadas( ) : false;
	}

	public boolean hasFuenteAnotado ( ) {
		return mo != null ? mo.hasFicheroAnotado( ) : false;
	}

	public boolean hasSalidaGprof ( ) {
		return mo != null ? mo.hasSalidaGprof() : false;
	}

	public boolean hasFicheroXML ( ) {
		return this.xml != null;
	}
	

}
