package modelo.vestadisticas.fuenteanotado;


import java.util.ArrayList;
import java.util.Vector;

import javax.swing.ComboBoxModel;
import javax.swing.ListModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

import modelo.modeloXML.FicheroAnotado;
import modelo.modeloXML.InterfazModeloXML;
import modelo.modeloXML.ModeloXML;
import modelo.vestadisticas.ModeloEstadistica;

public class ModeloListaFuentes implements InterfazModeloXML,  ListModel, ComboBoxModel {

	private final static long serialVersionUID = 1;
	
	private ModeloXML moXML;
	
	private ArrayList<ListDataListener> arrayListeners = new ArrayList<ListDataListener>();
	
	//private ResourceBundle propiedades = ResourceBundle.getBundle("interfaz.idiomas.Recursos", new Locale("es","ES"));

	private Vector < FicheroAnotado > listaFicheros = new Vector < FicheroAnotado > (0);
	
	int selected = -1;

	public ModeloListaFuentes () {
		
	}

	/**
	 * Crea el modelo de la lista a partir del modelo de datos ModeloXML.
	 * @param x ModeloXML que contiene toda la información.
	 */
	public ModeloListaFuentes ( ModeloEstadistica x ) {
		setDatosXML(x);
	}
	

	/**************METODOS**************/


	/* (non-Javadoc)
	 * @see javax.swing.ListModel#addListDataListener(javax.swing.event.ListDataListener)
	 */
	public void addListDataListener(ListDataListener l) {
		arrayListeners.add(l);
	}

	/* (non-Javadoc)
	 * @see javax.swing.ListModel#getElementAt(int)
	 */
	public Object getElementAt ( int index ) {
		return index < getSize() && index >= 0 ? listaFicheros.get(index) : null;
	}

	/* (non-Javadoc)
	 * @see javax.swing.ListModel#getSize()
	 */
	public int getSize() {
		return listaFicheros.size();
	}

	/* (non-Javadoc)
	 * @see javax.swing.ListModel#removeListDataListener(javax.swing.event.ListDataListener)
	 */
	public void removeListDataListener(ListDataListener l) {
		arrayListeners.remove(l);		
	}
	
	public void setDatosXML( ModeloEstadistica me ) {
		ModeloXML x = me.getModeloXML( );
		if ( x != null && x.hasFicheroAnotado( ) ) {
			moXML = x;
			listaFicheros = new Vector < FicheroAnotado > ( moXML.getFicherosAnotados().values() );
			fireListDataChanged();
			if ( listaFicheros.size( ) > 0 ) {
				this.setSelectedItem( listaFicheros.get( 0 ) );
			}
		}
	}
	
	/**
	 * 
	 */
	private void fireListDataChanged() {
		
		ListDataEvent evento = new ListDataEvent(this, 0, 0, 0);//consultar ayuda
		
		int i;

		for (i=0; i<arrayListeners.size(); i++)
		    ((ListDataListener)arrayListeners.get(i)).contentsChanged(evento);
		
	}

	/**
	 * Devuelve el objeto seleccionado. Si no hay ninguno seleccionado, devuelve null.
	 */
	@Override
	public Object getSelectedItem ( ) {
		return ( selected >= 0 && selected < listaFicheros.size( ) ) ? listaFicheros.get( selected ) : null;
	}

	@Override
	public void setSelectedItem ( Object o ) {
		if ( listaFicheros.contains( o ) ) {
			selected = listaFicheros.indexOf( o );
			fireListDataChanged();
		}
	}

}
