package modelo.vestadisticas.fuenteanotado;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import java.util.ResourceBundle;


import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;

import negocio.PreferenciasSingleton;

import modelo.modeloXML.FicheroAnotado;
import modelo.modeloXML.InterfazModeloXML;
import modelo.modeloXML.ModeloXML;
import modelo.vestadisticas.ModeloEstadistica;

public class ModeloTablaFuenteAnotado implements TableModel ,
		ListSelectionListener, ActionListener , InterfazModeloXML {
	private final static long					serialVersionUID	= 1;

	private ModeloXML							moXML;

	private ArrayList < TableModelListener >	arrayListeners		= new ArrayList < TableModelListener >( );

	private ResourceBundle						propiedades			= ResourceBundle
																			.getBundle(
																					"interfaz.idiomas.Recursos" , 
																					PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );

	private final String []						nombreDeColumnas	= {
			propiedades.getString( "eti_MoFA_num" ),
			propiedades.getString( "eti_MoFA_ejecuciones" ),
			propiedades.getString( "eti_MoFA_lineaO" )				};

	public final static int						NUMERO_LINEA		= 0;
	public final static int						EJECUCIONES			= 1;
	public final static int						LINEA_ORIGINAL		= 2;

	private String								nombreFuncion		= null;
	private FicheroAnotado						ficheroAnotado		= null;

	// private HashMap <String, Object[]> datosEntradas = new HashMap<String,
	// Object[]>();

	// private String nombreFuncion = new String();
	// private String[] nombres;

	public ModeloTablaFuenteAnotado ( ) {
	}

	/**
	 * Crea el modelo de la tabla a partir del modelo de datos ModeloXML.
	 * 
	 * @param x
	 *            ModeloXML que contiene toda la información.
	 */
	public ModeloTablaFuenteAnotado ( ModeloEstadistica x ) {
		setDatosXML( x );
	}

	/************** METODOS **************/
	public void addTreeModelListener ( TableModelListener l ) {
		arrayListeners.add( l );
	}

	public void removeTreeModelListener ( TableModelListener l ) {
		arrayListeners.remove( l );
	}

	public int getColumnCount ( ) {
		return nombreDeColumnas.length;
	}

	public int getRowCount ( ) {
		int result = 0;
		if ( moXML != null && nombreFuncion != null ) {
			result = this.ficheroAnotado.getSize( ); // (
														// funcionesLlamadorasMiembro
														// != null) ?
														// funcionesLlamadorasMiembro.size()
														// : 0;
		}
		return result;
	}

	public String getColumnName ( int col ) {
		return nombreDeColumnas[col];
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.swing.table.TableModel#getColumnClass(int)
	 */
	public Class < ? > getColumnClass ( int columnIndex ) {
		Class < ? > result = String.class;
		switch ( columnIndex ) {
		case NUMERO_LINEA :
			result = Integer.class;
			break;
		case EJECUCIONES :
			result = Integer.class;
			break;
		case LINEA_ORIGINAL :
			result = String.class;
			break;
		}

		return result;
	}

	public Object getValueAt ( int row , int col ) {
		Object result = null;
		if ( moXML != null && nombreFuncion != null && row >= 0
				&& row < getRowCount( ) && col >= 0 && col < getColumnCount( ) ) {
			row++; // porque row empieza en 0 y las líneas del fichero en 1;
			switch ( col ) {
			case NUMERO_LINEA :
				result = ficheroAnotado.getLineasAnotadas( ).containsKey(
						new Integer( row ) ) ? ficheroAnotado
						.getLineasAnotadas( ).get( new Integer( row ) )
						.getNumeroLinea( ) : null;
				break;
			case EJECUCIONES :
				result = ficheroAnotado.getLineasAnotadas( ).containsKey(
						new Integer( row ) ) ? ficheroAnotado
						.getLineasAnotadas( ).get( new Integer( row ) )
						.getEjecuciones( ) : null;
				break;
			case LINEA_ORIGINAL :
				result = ficheroAnotado.getLineasAnotadas( ).containsKey(
						new Integer( row ) ) ? ficheroAnotado
						.getLineasAnotadas( ).get( new Integer( row ) )
						.getLineaOriginal( ) : null;
				break;
			}
		}
		return result;
	}

	public boolean isCellEditable ( int row , int col ) {
		return false;
	}

	public void setValueAt ( Object value , int row , int col ) {
		// Insertar. Esta tabla es de solo lectura. No necesita hacer nada.
	}

	/**
	 * 
	 */
	private void fireTableDataChanged ( ) {
		TableModelEvent evento = new TableModelEvent( this );

		int i;

		for ( i = 0 ; i < arrayListeners.size( ) ; i++ )
			( (TableModelListener) arrayListeners.get( i ) )
					.tableChanged( evento );
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * javax.swing.table.TableModel#addTableModelListener(javax.swing.event.
	 * TableModelListener)
	 */
	public void addTableModelListener ( TableModelListener l ) {

		arrayListeners.add( l );
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * javax.swing.table.TableModel#removeTableModelListener(javax.swing.event
	 * .TableModelListener)
	 */
	public void removeTableModelListener ( TableModelListener l ) {
		arrayListeners.remove( l );
	}

	public void setDatosXML ( ModeloEstadistica me ) {
		ModeloXML x = me.getModeloXML( );
		if ( x != null && x.hasFicheroAnotado( ) ) {
			moXML = x;
			fireTableDataChanged( );
		}
	}


	/* (non-Javadoc)
	 * 
	 * @see
	 * javax.swing.event.ListSelectionListener#valueChanged(javax.swing.event
	 * .ListSelectionEvent)
	 * 
	//Cambio de JList a JComboBox... */
	 
	public void valueChanged ( ListSelectionEvent e ) {
		FicheroAnotado fichero = null;

		if ( e.getSource( ) instanceof JList ) {
			fichero = (FicheroAnotado) ( (JList) e.getSource( ) )
					.getSelectedValue( );
			setFicheroActivo( fichero.getNombreFichero( ) );
		}
	}
	
	
	@Override
	public void actionPerformed ( ActionEvent e ) {
		FicheroAnotado fichero = null;

		if ( e.getSource( ) instanceof JComboBox ) {
			fichero = (FicheroAnotado) ( (JComboBox ) e.getSource( ) )
					.getSelectedItem( );
			if ( fichero != null ) {
			setFicheroActivo( fichero.getNombreFichero( ) );
			}
		}
	}

	/**
	 * @param nombreFuncion
	 */
	public void setFicheroActivo ( String nombreFichero ) {
		if ( moXML != null && moXML.hasGrafoLlamadas( )
				&& moXML.getFicherosAnotados( ).containsKey( nombreFichero ) ) {
			this.nombreFuncion = nombreFichero;
			this.ficheroAnotado = moXML.getFicherosAnotados( ).get(
					nombreFichero );
			this.fireTableDataChanged( );
		}
	}


}
