/**
 * 
 */
package modelo.vestadisticas.grafollamadas;
import modelo.modeloXML.*;
import modelo.vestadisticas.ModeloEstadistica;


import java.util.ArrayList;
import java.util.Vector;

import javax.swing.ComboBoxModel;
import javax.swing.ListModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;


/**
 * @author angel
 *
 */
public class ModeloListaFunciones implements InterfazModeloXML, ListModel, ComboBoxModel, TreeSelectionListener {

	private final static long serialVersionUID = 1;
	
	private ModeloXML moXML;
	
	private ArrayList<ListDataListener> arrayListeners = new ArrayList<ListDataListener>();
	
	/*private ResourceBundle propiedades = ResourceBundle.getBundle("interfaz.idiomas.Recursos", new Locale("es","ES"));*/

	private Vector < EntradaFuncion > listaFunciones = new Vector < EntradaFuncion > (0);
	private Vector < Ciclo > listaCiclos = new Vector < Ciclo > (0);//new
	
	int selected = -1;

	public ModeloListaFunciones () {
		
	}

	/**
	 * Crea el modelo de la lista a partir del modelo de datos ModeloXML.
	 * @param x ModeloXML que contiene toda la información.
	 */
	public ModeloListaFunciones ( ModeloEstadistica x ) {
		setDatosXML(x);
	}
	

	/**************METODOS**************/


	/* (non-Javadoc)
	 * @see javax.swing.ListModel#addListDataListener(javax.swing.event.ListDataListener)
	 */
	public void addListDataListener(ListDataListener l) {
		arrayListeners.add(l);
	}

	/* (non-Javadoc)
	 * @see javax.swing.ListModel#getElementAt(int)
	 */
	public Object getElementAt ( int index ) {
		//return index < getSize() ? listaFunciones.get(index) : null;
		int entradas = getSize( );
		int ciclos = getNumberOfCycles( );
		
		Object o = null;
		if ( index >= 0 && index < entradas - ciclos )
			o = listaFunciones.get( index );
		else if( index >= entradas-ciclos && index < entradas )
			o = listaCiclos.get( index - entradas + ciclos );
		
		return o; 
	}

	/* (non-Javadoc)
	 * @see javax.swing.ListModel#getSize()
	 */
	public int getSize() {
		//return listaFunciones.size();
		return listaFunciones.size() + listaCiclos.size( );
	}
	
	public int getNumberOfCycles() {
		return listaCiclos.size( );
	}

	/* (non-Javadoc)
	 * @see javax.swing.ListModel#removeListDataListener(javax.swing.event.ListDataListener)
	 */
	public void removeListDataListener(ListDataListener l) {
		arrayListeners.remove(l);		
	}
	
	public void setDatosXML( ModeloEstadistica me ) {
		ModeloXML x = me.getModeloXML( );
		if ( x != null && x.hasGrafoLlamadas() ) {
			moXML = x;
			listaFunciones = new Vector < EntradaFuncion > ( moXML.getEntradasFuncion().values() );
			listaCiclos = new Vector < Ciclo > (moXML.getCiclos( ).values( ) );//new
			fireListDataChanged();
			if ( listaFunciones.size( ) > 0 ) { 
				this.setSelectedItem( listaFunciones.get( 0 ) );
			} else if ( listaCiclos.size( ) > 0 ) { //new
				this.setSelectedItem( listaCiclos.get( 0 ) ); //new
			} //new
		}
	}
	
	/**
	 * 
	 */
	private void fireListDataChanged() {
		
		ListDataEvent evento = new ListDataEvent(this, 0, 0, 0);//TODO consultar ayuda
		
		int i;

		for (i=0; i<arrayListeners.size(); i++)
		    ((ListDataListener)arrayListeners.get(i)).contentsChanged(evento);
		
	}

	/**
	 * Devuelve el objeto seleccionado. Si no hay ninguno seleccionado, devuelve null.
	 */
	@Override
	public Object getSelectedItem ( ) {
		//return ( selected >= 0 && selected < listaFunciones.size( ) ) ? listaFunciones.get( selected ) : null;		
		return ( selected >= 0 && selected < this.getSize() ) ? getElementAt( selected ) : null; 
	}

	@Override
	public void setSelectedItem ( Object o ) {
		if ( listaFunciones.contains( o ) ) {
			selected = listaFunciones.indexOf( o );
			fireListDataChanged();
		} else if ( listaCiclos.contains( o ) ) { //new
			selected = listaCiclos.indexOf( o ) + getSize( ) - getNumberOfCycles( ); //new
			fireListDataChanged(); //new
		}
	}

	@Override
	public void valueChanged ( TreeSelectionEvent e ) {
			EntradaFuncion funcion = null;
			Ciclo ciclo = null;
			TreePath tp = e.getPath();

			DefaultMutableTreeNode n = null;
			if(tp.getLastPathComponent() instanceof DefaultMutableTreeNode) {
				n = (DefaultMutableTreeNode) tp.getLastPathComponent();
				if( n.getUserObject() instanceof EntradaFuncion ) {
					funcion = (EntradaFuncion) n.getUserObject();
					
					setSelectedItem ( funcion );
				} else if ( n.getUserObject() instanceof Ciclo ) { //new
					ciclo = (Ciclo) n.getUserObject(); //new
					
					setSelectedItem ( ciclo ); //new
				} //new
			}
		
	}

}
