package modelo.vgprof;

import interfaz.dialogos.error.DialogoError;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import modelo.ficheros.UtilidadesFichero;
import negocio.PreferenciasSingleton;

public class ModeloGprof {
	
	/** recursos de idiomas para errores */
	static ResourceBundle errores = ResourceBundle.getBundle("interfaz.errores.Errores", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	
	private File					programa = null;
	
	private File					datosEjecucion = null;
	
	private File					salida	= null;
	
	private String					nombreSalida = null;
	
	private File					directorioTrabajo	= PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getWorkspaceGprof( );

	private Vector <String>				gprof			= PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getComandoGprof( );
	
	private String	salida_s;

	public static String extension = ".gprof";
	

	// TODO es un problema el tener el nombrePrograma  a null
	// un solución es coger los nombres por defecto de
	// Preferencias.



	ArrayList < ChangeListener >	listeners			= new ArrayList < ChangeListener >( 0 ); // listeners

	
	public void addChangeListener ( ChangeListener listener ) {
		listeners.add( listener );
	}

	public void removeChangeListener ( ChangeListener listener ) {
		listeners.remove( listener );
	}

	private void OnChange ( ) {
		ChangeEvent e = new ChangeEvent( this );
		Iterator < ChangeListener > it = listeners.iterator( );
		while ( it.hasNext( ) ) {
			it.next( ).stateChanged( e );
		}
	}

/*	public DefaultListModel getFicherosListModel ( ) {
		return molstFicheros;
	}

	@SuppressWarnings ( "unchecked" )
	public ArrayList < File > getListaFicheros ( ) {
		ArrayList < File > ficheros = (ArrayList < File >) Collections
				.list( molstFicheros.elements( ) );
		return ficheros;
	}*/

	public File getDirectorioTrabajo ( ) {
		return directorioTrabajo;
	}

	public void setDirectorioTrabajo ( File dir ) {
		this.directorioTrabajo = dir;
		OnChange( );
	}

	public String getNombreSalidaGprof ( ) {
		return nombreSalida;
	}

	public void setNombreSalidaGprof ( String nombre ) {

		if ( nombre != null && nombre.compareTo( "" ) != 0 ) {
			if( !nombre.endsWith( extension ) ) {
				nombre += extension;
			}
		}
		else
			nombre = null;
			
		this.nombreSalida = nombre;
		OnChange( );
	}
/*
	public String [] getComandoCompilacion ( ) {
		String [] resultado;
		if ( this.isComandoAuto() == false ) {
			resultado = new String [] { comando };
		} else {
			resultado = this.getComandoCompilacionAuto( );
		}
		return resultado;
	}
*/
	public String [] getComandoGprofAuto ( ) {

		LinkedList  < String > resultado = new LinkedList < String >( );
		// 1º) Preparar orden Gprof ****************

		// 1.a) orden gprof 
		resultado.addAll( getComandoGprof() );
		
		// 1.b) añadir programa
		File normal = getPrograma();
		if ( normal != null  && normal.exists( ) ) {
			if ( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getUseCanonicalFileName( ) ) {
				try {
					resultado.add( normal.getCanonicalPath( ) );
				} catch ( IOException e ) {
					resultado.add( normal.getName( ) );
				}
			}
			else { //cortos
				try {
						resultado.add( new UtilidadesFichero().getRelativePath(getDirectorioTrabajo( ), normal ) );
				} catch ( IOException e ) {
					DialogoError.getInstance( ).showErrorDialog( 
							errores.getString( "err_relativepath" ) );
				}
			}
		}else { //normal is null
			resultado.add( "a.out" );
			
		}
		
		// 1.c) añadir gmon
		File gmon = getArchivoDatos( );
		if ( gmon != null  && gmon.exists( )) {
			if ( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getUseCanonicalFileName( ) ) {
				try {
					resultado.add( gmon.getCanonicalPath( ) );
				} catch ( IOException e ) {
					resultado.add( gmon.getName( ) );
				}
			}
			else { //cortos
					try {
						resultado.add( new UtilidadesFichero().getRelativePath(getDirectorioTrabajo( ), gmon ) );
					} catch ( IOException e ) {
						DialogoError.getInstance( ).showErrorDialog( 
								errores.getString( "err_relativepath" ) );
				}
			}
		}
		else {
			resultado.add( "gmon.out" );
		}
		

		String [] t = new String [resultado.size( )];
		return resultado.toArray( t );
	}

	public Vector <String> getComandoGprof ( ) {
		return gprof;
	}

	public void setComandoGprof ( Vector <String> vs ) {
		if ( vs != null && vs.size( ) > 0 ) {
			gprof = vs;
		
			OnChange();
		}
	}


	public void setPrograma ( File prog ) {
		this.programa = prog;
		if( prog != null ) {
			this.setNombreSalidaGprof( this.programa.getName( ) );
		}
		OnChange();
	}

	public void setArchivoDatos ( File gmon ) {
		this.datosEjecucion = gmon;
		OnChange();
	}

	public File getArchivoDatos ( ) {
		return this.datosEjecucion;
	}

	public File getPrograma ( ) {
		return programa;
	}

	public void setFicheroSalida ( File file ) {
		this.salida = file;
		OnChange();		
	}
	
	public File getFicheroSalida (){
		return this.salida;
	}

	public void setSalida ( String salida ) {
		this.salida_s = salida;	
		
		OnChange();
	}
	
	public String getSalidaGprof() {
		return salida_s;
	}

	public boolean isGprofed ( ) {
		File salida = this.getFicheroSalida( );
		return ( salida != null && salida.exists( ) );
	}


}
